// CCFPS.cpp: implementation of the CCFPS class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "eimpred.h"
#include "CFPS.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CFPS::CFPS()
{
	TotalTime = 0;
	TotalFps = 0;
	RefreshTime = 1.0f;							//    CFPS  
	FrameRate = 0;
	FrameCount = 0;
}

CFPS::CFPS(float Interval)
{
	TotalTime = 0;
	TotalFps = 0;
	RefreshTime = Interval;
	FrameRate = 0;
	FrameCount = 0;
}

CFPS::~CFPS()
{
}

GLfloat CFPS::DoTimerStuff(void)
{
	static float Timer = 0.0f;
	static DWORD PrevTime = timeGetTime();

	FrameCount++;										//        CFPS	
	DWORD NowTime = timeGetTime();						//  
	Elapsed = (float)(NowTime - PrevTime)/1000.0f;		//         
	Timer+=Elapsed;										//       CFPS

	if (Timer>=RefreshTime)								//   CFPS   RefreshTime 
	{
		FrameRate = ((float)FrameCount)/Timer;
		FrameCount = 0;		
		Timer = 0.0f;
	}
	
	PrevTime = NowTime;
	return FrameRate;
}