#include "FPSClass.H"

FPS::FPS()
{
	TotalTime = 0;
	TotalFps = 0;
	RefreshTime = 1.0f;							//    fps  
	FrameRate = 0;
	FrameCount = 0;
}

FPS::FPS(float Interval)
{
	TotalTime = 0;
	TotalFps = 0;
	RefreshTime = Interval;
	FrameRate = 0;
	FrameCount = 0;
}

FPS::~FPS()
{
}

GLfloat FPS::DoTimerStuff(void)
{
	static float Timer = 0.0f;
	static DWORD PrevTime = timeGetTime();

	FrameCount++;										//        FPS	
	DWORD NowTime = timeGetTime();						//  
	Elapsed = (float)(NowTime - PrevTime)/1000.0f;		//         
	Timer+=Elapsed;										//       FPS

	if (Timer>=RefreshTime)								//   FPS   RefreshTime 
	{
		FrameRate = ((float)FrameCount)/Timer;
		FrameCount = 0;		
		Timer = 0.0f;
	}
	
	PrevTime = NowTime;
	return FrameRate;
}
