// MainFrm.cpp : implementation of the CMainFrame class
//

#include "stdafx.h"
#include "eimpred.h"

#include "MainFrm.h"
#include "eimpredView.h"
#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CMainFrame

IMPLEMENT_DYNCREATE(CMainFrame, CFrameWnd)

BEGIN_MESSAGE_MAP(CMainFrame, CFrameWnd)
	//{{AFX_MSG_MAP(CMainFrame)
	ON_WM_CREATE()
	ON_WM_CLOSE()
	ON_COMMAND_RANGE(ID_PLUGINS1,ID_PLUGINS1END,OnPluginChange1)
	ON_COMMAND_RANGE(ID_PLUGINS2,ID_PLUGINS2END,OnPluginChange2)
	ON_COMMAND_RANGE(ID_PLUGINS3,ID_PLUGINS3END,OnPluginChange3)
	ON_COMMAND(ID_VIEW_MINIMAP, OnViewMinimap)
	ON_COMMAND(ID_VIEW_WIREFRAME, OnViewWireframe)
	ON_COMMAND(ID_VIEW_NORMALS, OnViewNormals)
	ON_COMMAND(ID_SET_SHOWLIGHT, OnSetShowlight)
	ON_COMMAND(ID_VIEW_PLUGINSDIALOGBAR, OnViewPluginsdialogbar)
	ON_COMMAND(ID_VIEW_PCPANEL, OnViewPcpanel)
	ON_COMMAND(ID_VIEW_PGPANEL, OnViewPgpanel)
	ON_COMMAND(ID_VIEW_PTPANEL, OnViewPtpanel)
	ON_COMMAND(ID_VIEW_MAPOBJECTS_LANDSCAPE, OnViewMapobjectsLandscape)
	ON_WM_LBUTTONDBLCLK()
	ON_WM_LBUTTONDOWN()
	ON_WM_MOUSEMOVE()
	ON_WM_RBUTTONDBLCLK()
	ON_WM_RBUTTONDOWN()
	ON_COMMAND(ID_VIEW_MAPOBJECTS_WATER, OnViewMapobjectsWater)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

static UINT indicators[] =
{
	ID_SEPARATOR,           // status line indicator
	ID_INDICATOR_CAPS,
	ID_INDICATOR_NUM,
	ID_INDICATOR_SCRL,
};
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
CMainFrame::CMainFrame()
{
	// TODO: add member initialization code here
}
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
CMainFrame::~CMainFrame()
{
	delete pluginManager;
}
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
int CMainFrame::OnCreate(LPCREATESTRUCT lpCreateStruct)
{
	if (CFrameWnd::OnCreate(lpCreateStruct) == -1)
		return -1;
	if (!m_wndToolBar.CreateEx(this, TBSTYLE_FLAT , WS_CHILD | WS_VISIBLE | CBRS_TOP
		| CBRS_GRIPPER | CBRS_TOOLTIPS | CBRS_FLYBY | CBRS_SIZE_DYNAMIC,CRect(0,0,0,0),NextId()) ||
		!m_wndToolBar.LoadToolBar(IDR_MAINFRAME))
	{
		TRACE0("Failed to create toolbar\n");
		return -1;      // fail to create
	}
	if (!m_wndStatusBar.Create(this,WS_CHILD | WS_VISIBLE | CBRS_BOTTOM,NextId()) ||
		!m_wndStatusBar.SetIndicators(indicators,
		  sizeof(indicators)/sizeof(UINT)))
	{
		TRACE0("Failed to create status bar\n");
		return -1;
	}
	if (!m_wndMyBar.Create( this, IDD_PLUGINS_BASE, CBRS_LEFT | WS_CAPTION | WS_POPUPWINDOW , NextId() ))
	{
	    TRACE0("Failed to create mybar\n");
	    return -1;
	}
	myBar = &m_wndMyBar;

	m_wndMyBar.SetBarStyle(m_wndMyBar.GetBarStyle() | 
						    CBRS_TOOLTIPS | CBRS_FLYBY | CBRS_SIZE_DYNAMIC);


	EnableDocking(CBRS_ALIGN_ANY);
	m_wndToolBar.EnableDocking(CBRS_ALIGN_ANY );
	DockControlBar(&m_wndToolBar, AFX_IDW_DOCKBAR_TOP);
	pluginManager = new CPluginManager;
	pluginManager->Create( this,&m_wndToolBar );
	m_wndMyBar.EnableDocking(CBRS_ALIGN_LEFT | CBRS_ALIGN_RIGHT);
	DockControlBar(&m_wndMyBar, AFX_IDW_DOCKBAR_LEFT);
	LoadBarState( "dock\\bars" );

//	m_pbar.Create( this,59501,"gonewo", CSize(100,350), CBRS_TOP | CBRS_FLOATING , CBRS_XT_DEFAULT);
//	m_pbar.EnableDocking(0);
//	DockControlBar(&m_pbar); 

//////////////////////////////////////////////////////////////////////////////
//  CString file;
//	file.Format( "%s\\Config\\lightsgipat.ini",EIgamedir );
//	lightscavegipat.Load( file );
//	file.Format( "%s\\Config\\lightscaveingos.ini",EIgamedir );
//	lightscaveingos.Load( file );
//	file.Format( "%s\\Config\\lightscavesuslanger.ini",EIgamedir );
//	lightscavesuslanger.Load( file );
//	file.Format( "%s\\Config\\lightsgipat.ini",EIgamedir );
//	lightsgipat.Load( file );
//	file.Format( "%s\\Config\\lightsingos.ini",EIgamedir );
//	lightsingos.Load( file );
//	file.Format( "%s\\Config\\lightssuslanger.ini",EIgamedir );
//	lightssuslanger.Load( file );
//////////////////////////////////////////////////////////////////////////////
	return 0;
}
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
BOOL CMainFrame::PreCreateWindow(CREATESTRUCT& cs)
{
	if( !CFrameWnd::PreCreateWindow(cs) )
		return FALSE;
	// TODO: Modify the Window class or styles here by modifying
	//  the CREATESTRUCT cs

	return TRUE;
}
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
#ifdef _DEBUG
void CMainFrame::AssertValid() const
{
	CFrameWnd::AssertValid();
}
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
void CMainFrame::Dump(CDumpContext& dc) const
{
	CFrameWnd::Dump(dc);
}
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CMainFrame message handlers

void CMainFrame::OnPluginChange1( UINT nID ) 
{
	// TODO: Add your command handler code here
	int c_pl = nID - ID_PLUGINS1;
	pluginManager->SetActiveCameraPlugin( c_pl );
	
}

void CMainFrame::OnPluginChange2( UINT nID ) 
{
	// TODO: Add your command handler code here
	int c_pl = nID - ID_PLUGINS2;
	pluginManager->SetActiveGeometryPlugin( c_pl );
	
}

void CMainFrame::OnPluginChange3( UINT nID ) 
{
	// TODO: Add your command handler code here
	int c_pl = nID - ID_PLUGINS3;
	pluginManager->SetActiveTSPlugin( c_pl );
	
}

void CMainFrame::OnClose() 
{
	// TODO: Add your message handler code here and/or call default
	
	SaveBarState( "dock\\bars" );
	CFrameWnd::OnClose();
//	delete Log;
}

void CMainFrame::OnViewMinimap() 
{
	// TODO: Add your command handler code here
	MessageBox("       :    ,    ...","");
}

void CMainFrame::OnViewWireframe() 
{
	CEimpredView*	v = (CEimpredView*)GetActiveView();
	v->showWireFrame = !v->showWireFrame;
	// TODO: Add your command handler code here
	
}

void CMainFrame::OnViewNormals() 
{
	// TODO: Add your command handler code here
	CEimpredView*	v = (CEimpredView*)GetActiveView();
	v->showNormals = !v->showNormals;
}

void CMainFrame::OnSetShowlight() 
{
	// TODO: Add your command handler code here
	CEimpredView*	v = (CEimpredView*)GetActiveView();
	v->showLight = !v->showLight;
}

void CMainFrame::OnViewPluginsdialogbar() 
{
	// TODO: Add your command handler code here
//	m_wndMyBar.GetBarStyle();
//	m_wndMyBar.visibility = !m_wndMyBar.visibility;
	UINT	vis = m_wndMyBar.GetStyle() & WS_VISIBLE;
	ShowControlBar(&m_wndMyBar, !vis,  FALSE); 
}

void CMainFrame::OnViewPcpanel() 
{
	// TODO: Add your command handler code here
	UINT	vis = pluginManager->pCamera.GetStyle() & WS_VISIBLE;
//	pluginManager->pCamera.visibility = !pluginManager->pCamera.visibility;
	ShowControlBar(&pluginManager->pCamera, !vis,  FALSE); 
}

void CMainFrame::OnViewPgpanel() 
{
	// TODO: Add your command handler code here
	UINT	vis = pluginManager->pGeometryStage.GetStyle() & WS_VISIBLE;
//	pluginManager->pGeometryStage.visibility = !pluginManager->pGeometryStage.visibility;
	ShowControlBar(&pluginManager->pGeometryStage, !vis,  FALSE); 
}

void CMainFrame::OnViewPtpanel() 
{
	// TODO: Add your command handler code here
	UINT	vis = pluginManager->pTextureStage.GetStyle() & WS_VISIBLE;
//	pluginManager->pTextureStage.visibility = !pluginManager->pTextureStage.visibility;
	ShowControlBar(&pluginManager->pTextureStage, !vis,  FALSE); 
}

void CMainFrame::OnViewMapobjectsLandscape() 
{
	// TODO: Add your command handler code here
	CEimpredView*	v = (CEimpredView*)GetActiveView();
	v->showLand = !v->showLand;
}

void CMainFrame::OnViewMapobjectsWater() 
{
	// TODO: Add your command handler code here
	CEimpredView*	v = (CEimpredView*)GetActiveView();
	v->showWater = !v->showWater;
}
