#include "stdafx.h"
#include "OptionsManager.h"
#include <windows.h>
#include <shlwapi.h>
#include <winerror.h>
#include "MySys.h"


// COptManager

COptManager::COptManager(CEimpredApp *PAppObj)
{
	//
	//    ...
	PAppObject = PAppObj;

	//       ...
	//  ...
	int bufflength = strlen(PAppObject->m_pszHelpFilePath)-11;
	ProgDir.GetBufferSetLength(bufflength);
	memcpy(ProgDir.GetBuffer(0),PAppObject->m_pszHelpFilePath,bufflength);
	//MessageBox(NULL,ProgDir,"",MB_OK);   //    ...
	chdir(ProgDir);
	Log = new CLogFile;
	Log->AddLog( "    ,  -", CLogFile::modeOk );

	//  -     (   -   )
	LoadOptsFromIni();

};

COptManager::~COptManager()
{
	//
};

bool COptManager::LoadOptsFromIni()
//   ...
{
	//...
	LONG ReturnInfo;
	HKEY RegKey;
	bool RegPathFinded = false;
	unsigned long DateSize;
	

	Log->AddLog( "    "+ProgDir+IniName, CLogFile::modeOk );
	
	if (PathFileExists(ProgDir+IniName))
	{
		//  ...

		//  -       -    :).
		MatchIniVersion();

		//  -   ...
		//   -     .
		LastDir.GetBufferSetLength(256);
		DateSize = GetPrivateProfileString( "MainOptions","LastDir",ProgDir,LastDir.GetBuffer(0),256,ProgDir+IniName);
		LastDir.GetBufferSetLength(DateSize);
		//MessageBox(NULL,IntToStr(LastDir.GetLength()),"",MB_OK);
		

		GameDir.GetBufferSetLength(256);
		DateSize = GetPrivateProfileString( "MainOptions","GameDir",ProgDir,GameDir.GetBuffer(0),256,ProgDir+IniName);
		GameDir.GetBufferSetLength(DateSize);
		Log->AddLog( "", CLogFile::modeOk );
	}
	else
	{
		//  ... ...
		Log->AddLog( " "+ProgDir+IniName+"  .  ...", CLogFile::modeOk );

		//  -  ...
		//  ...
		LastDir = ProgDir;

		//  ...
		//    ...
		//  ...
		ReturnInfo = RegOpenKeyEx(HKEY_CURRENT_USER,"Software\\Nival Interactive\\EvilIslands\\Path Settings",0,KEY_QUERY_VALUE,&RegKey);
		if (ReturnInfo == ERROR_SUCCESS)
		{
			//    ...     ...
			RegQueryValueEx(RegKey,"WORK PATH",0,NULL,NULL,&DateSize);  //     ...
			DateSize = DateSize;
			GameDir.GetBufferSetLength(DateSize);  //  
			//  .
			RegQueryValueEx(RegKey,"WORK PATH",0,NULL,reinterpret_cast <unsigned char*>(GameDir.GetBuffer(0)),&DateSize);
			//    ,    ....
			if (PathFileExists(GameDir))
			{
				// .  .
				RegPathFinded = true;
			};
		};
		
		//        -   .
		if (!RegPathFinded)
		{
			GameDir = ProgDir;
			GetEIFolder(GameDir.GetBuffer(0));
		};

		//     - .
		if (!PathFileExists(GameDir))
		{
			Log->AddLog( "     :(.", CLogFile::modeFail );
			exit(EXIT_FAILURE);
		};

		//MessageBox(NULL,GameDir,"",MB_OK);   //    ...

		//       .
		SaveOptsToIni();
		Log->AddLog( "", CLogFile::modeOk );
	};
	
	return true;
};	

void COptManager::MatchIniVersion()
{
	CString Ver="1";
	Ver.GetBufferSetLength(256);
	GetPrivateProfileString( "MainOptions","IniVer",Ver,Ver.GetBuffer(0),256,ProgDir+IniName );
	
	if(Ver != IniVer)
	{
		//:
		if(Ver=="Version Number")
		{
			//      
			Ver = "1";
			//  ,    %s-  :)
			WritePrivateProfileString("MainOptions","IniVer",Ver,ProgDir+IniName);
			//     :
				// ...  - ...
			//      
			Log->AddLog("    \""+Ver+"\"",CLogFile::modeOk);
		}

		// 
		if(Ver=="1")
		{
			//   -    
			Ver = "2";
			//  ,      %)
			WritePrivateProfileString("MainOptions","IniVer",Ver,ProgDir+IniName);
			//     :
				//:   
				WritePrivateProfileString("MainOptions","LastCamPath",ProgDir+"mainmenu.cam",ProgDir+IniName);
			//      
			Log->AddLog("    \""+Ver+"\"",CLogFile::modeOk);
		}
	}

    //    ...
	if(StrToInt(Ver)>StrToInt(IniVer))
	{
		//""  
		MessageBox(NULL,"!!!   !!!   %)\r\n,        "+IniVer+",   - "+Ver," !!!!!",0);
		// "" "  "
		MessageBox(NULL,"      ,       , ? ;)"," ...",0);
		//   
		Log->AddLog(" \"\" ! %)   !!!!!!!  : "+Ver,CLogFile::modeOk);
	}
}

bool COptManager::SaveOptsToIni()
//.    .
{
	//...
	WritePrivateProfileString("MainOptions","LastDir",LastDir,ProgDir+IniName);
	WritePrivateProfileString("MainOptions","GameDir",GameDir,ProgDir+IniName);
	WritePrivateProfileString("MainOptions","IniVer",IniVer,ProgDir+IniName);
	return true;
};

bool COptManager::GetEIFolder( char* path )
{
    bool result = false;
	CoInitialize(  NULL	);    
    LPMALLOC pMalloc;
    if (::SHGetMalloc(&pMalloc) == NOERROR) 
	{
        BROWSEINFO bi;
        ::ZeroMemory(&bi,sizeof bi);
		bi.lpszTitle = "    ";
		bi.lpfn = NULL;
		bi.ulFlags =  BIF_RETURNONLYFSDIRS;
        LPITEMIDLIST pidl = ::SHBrowseForFolder(&bi);
        if (pidl != NULL) {
            if (::SHGetPathFromIDList(pidl,path))
                result = true;
            pMalloc->Free(pidl);
        }
        pMalloc->Release();
    }
	return result;
};