// PluginManager1.cpp : implementation file
//
#include "stdafx.h"
#include "eimpred.h"
#include "PluginManager.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CPluginManager1
CPluginManager::CPluginManager()
{
}

CPluginManager::~CPluginManager()
{
}


/////////////////////////////////////////////////////////////////////////////
// CPluginManager1 message handlers

BOOL CPluginManager::Create( CFrameWnd* pParentWnd,CWnd* firstToolBar )
{
	CFileFind	f;
	chdir( ProgaOpts->ProgDir );
	Log->AddLog( "     "+ProgaOpts->ProgDir+"plugins", CLogFile::modeOk );
	BOOL bResult = f.FindFile( "plugins\\*.pc" );
	pCameraCount = 0;
	while( bResult )
	{
		bResult = f.FindNextFile();
		pCameraCount++;
	}
	f.Close();

	bResult = f.FindFile( "plugins\\*.pg" );
	pGeometryStageCount = 0;
	while( bResult )
	{
		bResult = f.FindNextFile();
		pGeometryStageCount++;
	}
	f.Close();
	bResult = f.FindFile( "plugins\\*.pt" );
	pTextureStageCount = 0;
	while( bResult )
	{
		bResult = f.FindNextFile();
		pTextureStageCount++;
	}
	f.Close();

	LoadPluginsGroup( &pCamera, CString("plugins\\*.pc"),
										ID_PLUGINS1,
									   pCameraCount,pParentWnd,59550);
	LoadPluginsGroup( &pGeometryStage, CString("plugins\\*.pg"),
												ID_PLUGINS2,
												pGeometryStageCount,pParentWnd,59551);

	LoadPluginsGroup( &pTextureStage, CString("plugins\\*.pt"), 
												ID_PLUGINS3,
												pTextureStageCount,pParentWnd,59552);

	return	TRUE;
}

CPlugin* CPluginManager::LoadPlugin( CString file )
{
	Log->AddLog( " : "+file, CLogFile::modeOk );
	HINSTANCE	h;
	h = AfxLoadLibrary( file );	
	if( !h )
	{
		Log->AddLog( "   !!!",CLogFile::modeFail );
		return NULL;
		//exit(-1);
	}
	else
	{
		CPlugin* (*getPlugin)();
		(FARPROC &)getPlugin = GetProcAddress( h, "getPlugin");
		if( getPlugin == NULL ) exit(-1);
		CPlugin*	pl = getPlugin();
		pl->Create( myBar );
		pl->SetWindowPos( NULL,0,20,200,1000, SWP_NOZORDER );
		return getPlugin();
	};
}

void CPluginManager::SetActiveCameraPlugin( int c_pl )
{

	if( currentPlugin != NULL )
	{
		currentPlugin->onPluginUnSelect();
		currentPlugin->ShowWindow( SW_HIDE );
	}
		
	TBBUTTON Button; 
	(pCamera.GetToolBarCtrl()).GetButton(c_pl,&Button);
	currentPlugin = (CPlugin*)Button.dwData;
	currentPlugin->map = map;
	currentPlugin->ShowWindow( SW_SHOW );
	currentPlugin->onPluginSelect();
}

void CPluginManager::SetActiveGeometryPlugin( int c_pl )
{

	if( currentPlugin != NULL )
	{
		currentPlugin->onPluginUnSelect();
		currentPlugin->ShowWindow( SW_HIDE );
	}
	TBBUTTON Button; 
	(pGeometryStage.GetToolBarCtrl()).GetButton(c_pl,&Button);
	currentPlugin = (CPlugin*)Button.dwData;
	currentPlugin->map = map;
	currentPlugin->ShowWindow( SW_SHOW );
	currentPlugin->onPluginSelect();
}

void CPluginManager::SetActiveTSPlugin( int c_pl )
{
	if( currentPlugin != NULL )
	{
		currentPlugin->onPluginUnSelect();
		currentPlugin->ShowWindow( SW_HIDE );
	}
	TBBUTTON Button; 
	(pTextureStage.GetToolBarCtrl()).GetButton(c_pl,&Button);
	currentPlugin = (CPlugin*)Button.dwData;
	currentPlugin->map = map;
	currentPlugin->ShowWindow( SW_SHOW );
	currentPlugin->onPluginSelect();
}

void CPluginManager::SetNonePlugin( )
{
	if( currentPlugin != NULL )
	{
		currentPlugin->onPluginUnSelect();
		currentPlugin->ShowWindow( SW_HIDE );
	}
	currentPlugin = NULL;
}

void CPluginManager::LoadPluginsGroup( CPluginsToolBar* pg,
									   CString path,
									   UINT base,
									   unsigned int	count,
									   CFrameWnd* pParentWnd,
									   UINT nID)
{
	int id;
	CRect r;

	pg->CreateEx(pParentWnd, TBSTYLE_FLAT, WS_CHILD | WS_VISIBLE | CBRS_TOP
		| CBRS_GRIPPER | CBRS_TOOLTIPS | CBRS_FLYBY, CRect(0, 0, 0, 0),
		NextId() );
	CToolBarCtrl* tbc = &pg->GetToolBarCtrl();

	pg->tips = new CToolTipCtrl;
	pg->tips->Create( tbc );
	pg->images->Create(32,32,ILC_COLOR32 | ILC_MASK,0,0);

	tbc->SetToolTips( pg->tips );
	tbc->SetButtonSize(CSize(40,38));
//	tbc->SetBitmapSize(CSize(32,32));

	CPlugin* plugin;
		CFileFind*	ff = new CFileFind;

		BOOL bResult = ff->FindFile( path );
		unsigned int i=0;
		while( bResult )
		{
			bResult = ff->FindNextFile();
			plugin = LoadPlugin( ff->GetFilePath() );
			TBBUTTON *t = new TBBUTTON;
			t->iBitmap = pg->images->Add(plugin->icon);
			t->idCommand = base + i;
			t->fsState = TBSTATE_ENABLED ;
			t->fsStyle = TBSTYLE_BUTTON;
			t->dwData = (unsigned long)plugin;
			tbc->AddButtons( 1,t);
			tbc->SetImageList( pg->images );
			id = base + i;
			tbc->GetItemRect( i, &r );
			CString s;
			pg->tips->AddTool(tbc, plugin->tip, &r, id);
			delete t;

			i++;
		}
		ff->Close();
		delete ff;


		pg->tips->Activate( true );

		pg->EnableDocking(CBRS_ALIGN_ANY );
		pParentWnd->DockControlBar( pg );
}