// eimpredView.cpp : implementation of the CEimpredView class
//

#include "stdafx.h"
#include "eimpred.h"

#include "eimpredView.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

float st=0;
/////////////////////////////////////////////////////////////////////////////
// CEimpredView

IMPLEMENT_DYNCREATE(CEimpredView, CView)

BEGIN_MESSAGE_MAP(CEimpredView, CView)
	//{{AFX_MSG_MAP(CEimpredView)
	ON_WM_CREATE()
	ON_WM_SIZE()
	ON_WM_KEYDOWN()
	ON_WM_LBUTTONDOWN()
	ON_WM_LBUTTONDBLCLK()
	ON_WM_MOUSEMOVE()
	ON_WM_RBUTTONDOWN()
	ON_WM_RBUTTONDBLCLK()
	ON_WM_MOUSEWHEEL()
	ON_WM_LBUTTONUP()
	ON_WM_RBUTTONUP()
//	ON_WM_TIMER()
	//}}AFX_MSG_MAP
	// Standard printing commands
	ON_COMMAND(ID_FILE_PRINT, CView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_DIRECT, CView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_PREVIEW, CView::OnFilePrintPreview)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////
int CEimpredView::InitOpenGL()
{
	Log->AddLog( " opengl:", CLogFile::modeOk );

    int m_GLPixelIndex;
    PIXELFORMATDESCRIPTOR pfd;

	memset( &pfd,0,sizeof(PIXELFORMATDESCRIPTOR) );
    pfd.nSize       = sizeof(PIXELFORMATDESCRIPTOR);
    pfd.nVersion    = 1;

    pfd.dwFlags   = PFD_DRAW_TO_WINDOW | 
                    PFD_SUPPORT_OPENGL | 
                    PFD_DOUBLEBUFFER;
    pfd.iPixelType     = PFD_TYPE_RGBA;
    pfd.cColorBits     = 32;
    pfd.cDepthBits     = 24;
    pfd.iLayerType     = PFD_MAIN_PLANE;



    m_GLPixelIndex = ChoosePixelFormat( DC, &pfd);
    if(m_GLPixelIndex==0)
    {
     m_GLPixelIndex = 1;    
     if(DescribePixelFormat(DC,m_GLPixelIndex,sizeof(PIXELFORMATDESCRIPTOR),&pfd)==0)
       return -1;
	}

    if (SetPixelFormat( DC, m_GLPixelIndex, &pfd)==FALSE)
        return -1;
	hGLRC = wglCreateContext( DC );
    if(hGLRC == NULL)
        return -1;
    if(wglMakeCurrent(DC, hGLRC)==FALSE)
        return -1;
	glewInit();
	glMatrixMode(GL_TEXTURE);
	glMatrixMode(GL_MODELVIEW);
	glLoadIdentity();
    glEnable(GL_DEPTH_TEST); 
	glDepthFunc( GL_LEQUAL );
	glEnable(GL_TEXTURE_2D);
	glEnable(GL_CULL_FACE);
	glCullFace(GL_BACK);

	glEnable(GL_NORMALIZE);

	texMan = new CTextureManager;
	resMan = new CResManager();
	Log->AddLog( " ", CLogFile::modeOk );
	return 1;
}
/////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////
CEimpredView::CEimpredView()
{
	// TODO: add construction code here
	_cfps = new CFPS(0.3f);
	showLight = false;
	showNormals = false;
	showWireFrame = false;
	showLand = showWater = true;
	Log->AddLog( "  ", CLogFile::modeOk );
}
/////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////
CEimpredView::~CEimpredView()
{
	delete texMan;
	delete _cfps;
}
/////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////
BOOL CEimpredView::PreCreateWindow(CREATESTRUCT& cs)
{
	// TODO: Modify the Window class or styles here by modifying
	//  the CREATESTRUCT cs

	return CView::PreCreateWindow(cs);
}
/////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////
void CEimpredView::OnDraw(CDC* pDC)
{
	CEimpredDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);
	// TODO: add draw code for native data here
}
/////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////
BOOL CEimpredView::OnPreparePrinting(CPrintInfo* pInfo)
{
	// default preparation
	return DoPreparePrinting(pInfo);
}
/////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////
void CEimpredView::OnBeginPrinting(CDC* /*pDC*/, CPrintInfo* /*pInfo*/)
{
	// TODO: add extra initialization before printing
}
/////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////
void CEimpredView::OnEndPrinting(CDC* /*pDC*/, CPrintInfo* /*pInfo*/)
{
	// TODO: add cleanup after printing
}
/////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////
#ifdef _DEBUG
void CEimpredView::AssertValid() const
{
	CView::AssertValid();
}
/////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////
void CEimpredView::Dump(CDumpContext& dc) const
{
	CView::Dump(dc);
}
/////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////
CEimpredDoc* CEimpredView::GetDocument() // non-debug version is inline
{
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CEimpredDoc)));
	return (CEimpredDoc*)m_pDocument;
}
#endif //_DEBUG
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
int CEimpredView::OnCreate(LPCREATESTRUCT lpCreateStruct) 
{
	if (CView::OnCreate(lpCreateStruct) == -1)
		return -1;
	
	// TODO: Add your specialized creation code here
	DC = GetDC()->m_hDC;
    if(InitOpenGL( )==FALSE)
	    return -1;	
//	this->SetTimer(12,1,0);
	ShowCamRect = false;
	return 0;
}
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
void CEimpredView::OnSize(UINT nType, int cx, int cy) 
{
	CView::OnSize(nType, cx, cy);
	
	// TODO: Add your message handler code here
	glMatrixMode(GL_PROJECTION);
	glLoadIdentity();
	glViewport(0,0,cx,cy);
	gluPerspective(60,(double)cx/(double)cy,1,15000);	
}
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
void CEimpredView::display()
{
		calcSunLight();
		//if(ShowCamRect)
			DrawCamRect(); // ,     
		static CString s;
		s.Format( "fps:%.2f",_cfps->DoTimerStuff() );
//		s.Format( "%f,%f,%f",map->cam.x,map->cam.y,map->cam.z );
		GetDocument()->SetTitle( s );
		Camera* cam = &(map->cam);
		glClear( GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT );
		glClearColor(.25f, .25f, .55f, .0f); 
		glMatrixMode(GL_MODELVIEW); 
		glPushMatrix();

/*			glRotatef(cam->VA,1,0,0);
			glRotatef(cam->HA,0,0,1);
			glTranslated(-cam->x,-cam->y,-cam->z);
*/
		map->cam.MoveAndRotate();
		map->display( showLand,showWater,false );
		glDisable(GL_LIGHTING);
		glDisable(GL_TEXTURE_2D);
		if( showNormals )
		{
			map->tree->displayNormals();
		}
		glEnable(GL_TEXTURE_2D);
		if( showWireFrame )
			map->displayWireFrame();
		if(currentPlugin)
		currentPlugin->display();
		glPopMatrix();
		glFlush();
}

void CEimpredView::DrawCamRect()
{
	// ,   

	CRect rect(0,0,0,0);
	GetWindowRect(rect);

    int w = rect.Width(), h = rect.Height();
	float k = 4/3.0f;
	int div=100, multL = 20, multR = 85, multT=25, multB=85;
	int l=w/div*multL;
	int r=w/div*multR;
	int t=h/div*multT;
	int b=h/div*multB;

	try
	{
	  CClientDC cd(this);
	  if(cd && map->cam.ShowRect)
	  {
	    cd.Rectangle(l,t,l+1,b);
	    cd.Rectangle(l,t,r,t+1);
	    cd.Rectangle(r,t,r+1,b);
	    cd.Rectangle(l,b,r,b+1);
	  }	  
	}
	catch(exception)
	{
		//const *char c = &CString::Format("Rectangle Eeeerrror! L: %d, R: %d, T: %d, B: %d; App will shut down.",l,r,t,b);
		Log->AddLog("Rectangle Error",CLogFile::modeFail);
	}
}

//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
void CEimpredView::OnKeyDown(UINT nChar, UINT nRepCnt, UINT nFlags) 
{
	// TODO: Add your message handler code here and/or call default
	Camera* cam = &map->cam;
	switch(nChar)
	{
		case VK_LEFT : // left arrow key down - left camera sliding
			cam->RotateH(-3 );
			break;
		case VK_RIGHT : // right arrow key down - right camera sliding
			cam->RotateH( 3 );
			break;
		case VK_UP :	// up arrow key down - forward camera sliding
			cam->Slide( 1 );
			break;
		case VK_DOWN :	// down arrow key down - backward camera sliding
			cam->Slide(-1 );
			break;
		case 33:
			cam->RotateV(-3 );
			break;
		case 34:
			cam->RotateV( 3 );
			break;
		case 35:
			cam->Fly( 0.15f );
			break;
		case 36:
			cam->Fly(-0.15f );
			break;
		default:
			break;
	}
	CView::OnKeyDown(nChar, nRepCnt, nFlags);
}
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
void CEimpredView::KeyMessages()
{
/*	static double lasttime = 0;
	double	thistime = timeGetTime();
	if( thistime - lasttime > 1 )
	{
		Camera* cam = &map->cam;
			if( GetAsyncKeyState(VK_LEFT)	<0 ) cam->RotateH(-3 );
			if( GetAsyncKeyState(VK_RIGHT) <0 ) cam->RotateH( 3 );
			if( GetAsyncKeyState(VK_UP)	<0 ) cam->Slide( 1 );
			if( GetAsyncKeyState(VK_DOWN)	<0 ) cam->Slide(-1 );
			if( GetAsyncKeyState(VK_PRIOR)	<0 ) cam->RotateV(-3 );
			if( GetAsyncKeyState(VK_NEXT)	<0 ) cam->RotateV( 3 );
			if( GetAsyncKeyState(VK_END)	<0 ) cam->Fly( 1 );
			if( GetAsyncKeyState(VK_HOME)	<0 ) cam->Fly(-1 );
		lasttime = thistime;
	}*/
}
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////

void CEimpredView::OnLButtonDown(UINT nFlags, CPoint point) 
{
	// TODO: Add your message handler code here and/or call default
	if( currentPlugin != NULL )
	currentPlugin->onLButtonDown( nFlags, point );
	ShowCamRect = true;
	CView::OnLButtonDown(nFlags, point);
}

void CEimpredView::OnLButtonDblClk(UINT nFlags, CPoint point) 
{
	// TODO: Add your message handler code here and/or call default
	
	if( currentPlugin != NULL )
	currentPlugin->onLButtonDblClk(nFlags, point);
	CView::OnLButtonDblClk(nFlags, point);
}

void CEimpredView::OnMouseMove(UINT nFlags, CPoint point) 
{
    //.
	if( currentPlugin != NULL )
	currentPlugin->onMouseMove(nFlags, point);
	CView::OnMouseMove(nFlags, point);
}

void CEimpredView::OnRButtonDown(UINT nFlags, CPoint point) 
{
	// TODO: Add your message handler code here and/or call default
	
	if( currentPlugin != NULL )
	currentPlugin->onRButtonDown(nFlags, point);
	ShowCamRect = true;
	CView::OnRButtonDown(nFlags, point);
}

void CEimpredView::OnRButtonDblClk(UINT nFlags, CPoint point) 
{
	// TODO: Add your message handler code here and/or call default
	
	if( currentPlugin != NULL )
	currentPlugin->onRButtonDblClk(nFlags, point);
	CView::OnRButtonDblClk(nFlags, point);
}

BOOL CEimpredView::OnMouseWheel(UINT nFlags, short zDelta, CPoint pt) 
{
	// TODO: Add your message handler code here and/or call default
//	if(zDelta>0)
//	map->cam.z += 1800;
//	else 
//	map->cam.z -= 1800;
//	map->cam.z += 100*zDelta;
	if( currentPlugin != NULL )
//	AfxMessageBox("goewo");
	currentPlugin->onMouseWheel(nFlags, zDelta, pt);
	return CView::OnMouseWheel(nFlags, zDelta, pt);
}

void CEimpredView::OnLButtonUp(UINT nFlags, CPoint point) 
{
	// TODO: Add your message handler code here and/or call default
	if( currentPlugin != NULL )
	currentPlugin->onLButtonUp( nFlags, point );
	ShowCamRect = false;
	CView::OnLButtonUp(nFlags, point);
}

void CEimpredView::OnRButtonUp(UINT nFlags, CPoint point) 
{
	// TODO: Add your message handler code here and/or call default
	if( currentPlugin != NULL )
	currentPlugin->onRButtonUp( nFlags, point );
	ShowCamRect = false;
	CView::OnRButtonUp(nFlags, point);
}

void CEimpredView::OnTimer(UINT nIDEvent) 
{
	// TODO: Add your message handler code here and/or call default
	CView::OnTimer(nIDEvent);
}

void CEimpredView::calcSunLight()
{
	static DWORD	time=0;
	DWORD	thistime;
	float past,minutes;
	int hour,h1,h2;

	thistime = timeGetTime();
	if( thistime - time > 10 )
	{
		past = ( thistime - time ) / 10.0f;
		time = thistime;
	}
	else
	{
		past = 0;
	}
	float a[4] = {0,0,1,0};
	float b[4] = {1.0,1.0,1.0,0};
	float dif[4] = {1.0,0.0,1.0,0};
	float mdif[4] = {1.0,1.0,1.0,0.5};
	st+= past;
	if ( st > 360.0f ) st = 0.0f;
	hour = (int)(st/360.0f*24.0f);
	minutes = (( st/360.0f*24.0f - hour ) * 4 );
	a[0] = (float)sin(st*3.141592f/180.0f);
	a[2] = (float)cos(st*3.141592f/180.0f);

	h1 = hour;
	h2 = (hour<23)?hour+1:0;
	glLightModelf(GL_LIGHT_MODEL_LOCAL_VIEWER,0);
//	glLightModeliv(GL_LIGHT_MODEL_AMBIENT,&light->ambient[hour].r);
//	glLightfv(GL_LIGHT1, GL_DIFFUSE, b);
//	glLightfv(GL_LIGHT1, GL_AMBIENT, b);
/*	static float color[3];
	float t = minutes / 60.0f;
	color[1] = (float)( light->sunlight[h1].g*(1.0f-t) + light->sunlight[h2].g*(1.0f-t)*t )/256.0f;
	color[2] = (float)( light->sunlight[h1].b*(1.0f-t) + light->sunlight[h2].b*(1.0f-t)*t )/256.0f;
	glLightfv(GL_LIGHT1, GL_DIFFUSE, color);
	
	h2=0;t=0;
	color[0] = (float)( light->ambient[h1].r*(1.0f-t) + light->ambient[h2].r*t )/256.0f;
	color[1] = (float)( light->ambient[h1].g*(1.0f-t) + light->ambient[h2].g*t )/256.0f;
	color[2] = (float)( light->ambient[h1].b*(1.0f-t) + light->ambient[h2].b*t )/256.0f;*/
	glLightfv(GL_LIGHT1, GL_AMBIENT, b);
	glLightfv(GL_LIGHT1, GL_DIFFUSE, b);
	glLightfv(GL_LIGHT1, GL_POSITION, a);
	glMaterialfv( GL_FRONT, GL_DIFFUSE , mdif );
	glColor4f( 1.0f,1.0f,1.0f,0.5f );
	glEnable(GL_LIGHT1); 
	if( showLight )	glEnable(GL_LIGHTING);

}
