#include "CFPS.h"
#include "eimpredDoc.h"
#include "LightModel.h"
// eimpredView.h : interface of the CEimpredView class
//
/////////////////////////////////////////////////////////////////////////////

#if !defined(AFX_EIMPREDVIEW_H__C038B2E5_15F9_4009_BC9A_9C46D1F1B2C8__INCLUDED_)
#define AFX_EIMPREDVIEW_H__C038B2E5_15F9_4009_BC9A_9C46D1F1B2C8__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

class CEimpredView : public CView
{
	friend	class CMainFrame;
	friend	class CEimpredApp;
protected: // create from serialization only
	CEimpredView();
	DECLARE_DYNCREATE(CEimpredView)

	int InitOpenGL();
// Attributes
public:
	CEimpredDoc* GetDocument();
	bool	showWireFrame,showNormals,showLight,showLand,showWater;

// Operations
public:
	void SwapBuffers( )
	{
		::SwapBuffers( DC);
	}
// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CEimpredView)
	public:
	virtual void OnDraw(CDC* pDC);  // overridden to draw this view
	virtual BOOL PreCreateWindow(CREATESTRUCT& cs);
	protected:
	virtual BOOL OnPreparePrinting(CPrintInfo* pInfo);
	virtual void OnBeginPrinting(CDC* pDC, CPrintInfo* pInfo);
	virtual void OnEndPrinting(CDC* pDC, CPrintInfo* pInfo);
	//}}AFX_VIRTUAL

// Implementation
public:
	void calcSunLight();
	void KeyMessages();
	void display();
	void DrawCamRect();

	bool ShowCamRect;
	virtual ~CEimpredView();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

protected:
// Generated message map functions
	CFPS*		_cfps;
	HDC DC;
	HGLRC	hGLRC;
	CLightModel*	light;
	//{{AFX_MSG(CEimpredView)
	afx_msg int OnCreate(LPCREATESTRUCT lpCreateStruct);
	afx_msg void OnSize(UINT nType, int cx, int cy);
	afx_msg void OnKeyDown(UINT nChar, UINT nRepCnt, UINT nFlags);
	afx_msg void OnLButtonDown(UINT nFlags, CPoint point);
	afx_msg void OnLButtonDblClk(UINT nFlags, CPoint point);
	afx_msg void OnMouseMove(UINT nFlags, CPoint point);
	afx_msg void OnRButtonDown(UINT nFlags, CPoint point);
	afx_msg void OnRButtonDblClk(UINT nFlags, CPoint point);
	afx_msg BOOL OnMouseWheel(UINT nFlags, short zDelta, CPoint pt);
	afx_msg void OnLButtonUp(UINT nFlags, CPoint point);
	afx_msg void OnRButtonUp(UINT nFlags, CPoint point);
	afx_msg void OnTimer(UINT nIDEvent);
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

#ifndef _DEBUG  // debug version in eimpredView.cpp
inline CEimpredDoc* CEimpredView::GetDocument()
   { return (CEimpredDoc*)m_pDocument; }
#endif

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_EIMPREDVIEW_H__C038B2E5_15F9_4009_BC9A_9C46D1F1B2C8__INCLUDED_)
