// Camera.cpp: implementation of the Camera class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "camera.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
Camera::Camera()
{
	cView.set( vec3(0,0,1),0);
	x = 0;
	y = 0;
	z = 100;
	HA = 45;
	VA = -45;
	YA = 0;
	ShowRect = false;
//	HA=0;VA=0;
}
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
Camera::Camera( float X,float Y,float Z,float hA,float vA, float yA )
{
	cView.set( vec3(0,0,1),0);
	x = X;
	y = Y;
	z = Z;
	HA = hA;
	VA = vA;
	YA = yA;
	ShowRect = false;
}
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
Camera::~Camera()
{

}
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
void Camera::RotateH( float angle )
{
	HA += angle;
	for(;HA>360;)
	{
		HA-=360;
	}
}
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
void Camera::RotateV( float angle )
{
	VA += angle;
	for(;VA>360;)
	{
		VA-=360;
	}
}
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
void Camera::RotateY( float angle )
{
	YA += angle;
	for(;YA>360;)
	{
		YA-=360;
	}
}

quat Camera::GetCameraQuat()
//  .
{
	//
	quat Result;

    Result = Result.Euler_To_Quaternion(vec3(-VA,180-YA,180-HA));
    
	//Result = qHA * qVA;

	// 
	return Result;

};
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
void Camera::Slide( float direction )
{
			x += direction*( /*128.0f**/(float)sin( HA * 0.01745328888888 ));
			y += direction*( /*128.0f**/(float)cos( HA * 0.01745328888888 ));
}
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
void Camera::Fly( float direction )
{
			z += direction*13;
}
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
void Camera::Clear()
{
	x = 0;
	y = 0;
	z = 100;
	HA = 0;
	VA = 0;
	YA = 0;
}
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
void Camera::MoveAndRotate()
{
	mat4 mrx,mry,mrz,mt;
	mrx.rotation_x( VA );
    mry.rotation_y( YA );
	mrz.rotation_z( HA );
	mt.translate( -x,-y,-z );
	mv = mrx*mry*mrz*mt;
	glMultMatrixf(&mv[0]);
}