// CMPHeader.cpp: implementation of the CMPHeader class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "MPHeader.h"
#include "LogFile.h"
#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CMPHeader::CMPHeader()
{

}

CMPHeader::~CMPHeader()
{
	delete objectArray;
	delete idArray;
	delete animArray;

}

void CMPHeader::Read()
{
	CFileFind	finder;
	BOOL bWorking = finder.FindFile("*.mp");
	if( bWorking )
	{
		finder.FindNextFile();
		cFileName = finder.GetFilePath( );
	}
	CFile f;
	if( !f.Open( cFileName, CFile::modeRead ) )
	{
		Log->AddLog( CString("can`t open .mp file " + cFileName  ),CLogFile::modeFail );
	}
	f.Read( &dwSignature,sizeof(DWORD) );
	f.Read( &fpMaxZ,sizeof(float) );
	f.Read( &dwXSectorsCount,sizeof(DWORD) );
	f.Read( &dwYSectorsCount,sizeof(DWORD) );
	f.Read( &dwTextures,sizeof(DWORD) );
	f.Read( &dwTexSize,sizeof(DWORD) );
	f.Read( &dwTiles,sizeof(DWORD) );
	f.Read( &dwTileSize,sizeof(DWORD) );
	f.Read( &wObjectsCount,sizeof(WORD) );
	f.Read( &dwAnimatedTiles,sizeof(DWORD) );

	objectArray = new SMapObject[wObjectsCount];
	idArray		= new int[dwTiles];
	animArray	= new STileAnimInfo[dwAnimatedTiles];
	f.Read( objectArray,sizeof(SMapObject)*wObjectsCount );
	f.Read( idArray,sizeof(int)*wObjectsCount );
	f.Read( animArray,sizeof(int)*dwAnimatedTiles );

	// -  .
	CString h;
	h.Format( "signature:%x",dwSignature );
	Log->AddLog( h,CLogFile::modeOk );
	h.Format( "fpMaxZ:%f",fpMaxZ );
	Log->AddLog( h,CLogFile::modeOk );
	h.Format( "dwXSectorsCount:%d",dwXSectorsCount );
	Log->AddLog( h,CLogFile::modeOk );
	h.Format( "dwYSectorsCount:%d",dwYSectorsCount );
	Log->AddLog( h,CLogFile::modeOk );
	h.Format( "dwTextures:%d",dwTextures );
	Log->AddLog( h,CLogFile::modeOk );
	h.Format( "dwTexSize:%d",dwTexSize );
	Log->AddLog( h,CLogFile::modeOk );
	h.Format( "dwTiles:%d",dwTiles );
	Log->AddLog( h,CLogFile::modeOk );
	h.Format( "dwTileSize:%d",dwTileSize );
	Log->AddLog( h,CLogFile::modeOk );
	h.Format( "wObjectsCount:%d",wObjectsCount );
	Log->AddLog( h,CLogFile::modeOk );
	h.Format( "dwAnimatedTiles:%d",dwAnimatedTiles );
	Log->AddLog( h,CLogFile::modeOk );

	Log->AddLog( "\nMap Objects",CLogFile::modeOk );
	Log->AddLog( "-----------",CLogFile::modeOk );

	for( int i=0;i<wObjectsCount;i++ )
	{
		h.Format( "OBJECT NUMBER %d", i );
		Log->AddLog( h, CLogFile::modeOk );
		h.Format( "fpR:%f, fpG:%f, fpB:%f", objectArray[i].fpR, objectArray[i].fpG, objectArray[i].fpB );
		Log->AddLog( h, CLogFile::modeOk );

		h.Format( "fpOpacity:%f, fpSelfIllum:%f, fpWaveMultiplier:%f", objectArray[i].fpOpacity, objectArray[i].fpSelfIllum, objectArray[i].fpWaveMultiplier );
		Log->AddLog( h, CLogFile::modeOk );
	}
	Log->AddLog( "-----------",CLogFile::modeOk );
}
