// MaterialDlg.cpp : implementation file
//

#include "stdafx.h"
#include "eimprrt.h"
#include ".\materialdlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif


/////////////////////////////////////////////////////////////////////////////
// CMaterialDlg dialog
/////////////////////////////////////////////////////////////////////////////


CMaterialDlg::CMaterialDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CMaterialDlg::IDD, pParent)
	, MatName(_T(""))
	, MatCode(_T("0"))
	, Tile_a(_T("0"))
	, Tile_b(_T("0"))
	, Tile_c(_T("0"))
	, Tile_d(_T("0"))
{
	//{{AFX_DATA_INIT(CMaterialDlg)
	//}}AFX_DATA_INIT
		pos.x = pos.y = currentTex = currentTitle = tmp = 0;
		clk.x = 26;
		clk.y = 244;
		pParentWnd = pParent;

}

void CMaterialDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CMaterialDlg)
	DDX_Control(pDX, IDC_TEX_SLIDER, m_TexSlider);
	//}}AFX_DATA_MAP
	DDX_Text(pDX, IDC_ED_MATNAME, MatName);
	DDX_Text(pDX, IDC_MATCODE, MatCode);
	DDX_Text(pDX, IDC_TILE_A, Tile_a);
	DDX_Text(pDX, IDC_TILE_B, Tile_b);
	DDX_Text(pDX, IDC_TILE_C, Tile_c);
	DDX_Text(pDX, IDC_TILE_D, Tile_d);
	DDX_Control(pDX, IDC_MAT_LIST, MList);
}


BEGIN_MESSAGE_MAP(CMaterialDlg, CDialog)
	//{{AFX_MSG_MAP(CMaterialDlg)
	ON_WM_PAINT()
	ON_WM_LBUTTONDOWN()
	ON_NOTIFY(NM_RELEASEDCAPTURE, IDC_TEX_SLIDER, OnReleasedcaptureTexSlider)
	ON_WM_CLOSE()
	//}}AFX_MSG_MAP
	ON_BN_CLICKED(IDC_APPLY_TILE, OnBnClickedApplyTile)
	ON_BN_CLICKED(IDC_SAVE_OPTS, OnBnClickedSaveOpts)
	ON_BN_CLICKED(IDC_TESTBUTTON, OnBnClickedTestbutton)
	ON_BN_CLICKED(IDC_GENERATE_OPTS, OnBnClickedGenerateOpts)
	ON_BN_CLICKED(IDC_ADD_MAT, OnBnClickedAddMat)
	ON_BN_CLICKED(IDC_APPLY_MAT, OnBnClickedApplyMat)
	ON_BN_CLICKED(IDC_KILL_MAT, OnBnClickedKillMat)
	ON_LBN_SELCHANGE(IDC_MAT_LIST, OnLbnSelchangeMatList)
	ON_BN_CLICKED(IDC_PUSH_TILE, OnBnClickedPushTile)
	ON_BN_CLICKED(IDC_CALL_TILE, OnBnClickedCallTile)
	ON_BN_CLICKED(IDOK, OnBnClickedOk)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CMaterialDlg message handlers

void CMaterialDlg::OnPaint() 
{
	CPaintDC dx ( this); // device context for painting
	CPaintDC dc ( GetDlgItem( IDC_TEXTURE ) ); // device context for painting
	CPaintDC tdc( GetDlgItem( IDC_TITLE ) );
	
	// TODO: Add your message handler code here
	 dc.BitBlt( 0,0,TITLE_MAP_SIZE,TITLE_MAP_SIZE,&dcMem,0,0,SRCCOPY);
	tdc.BitBlt( 0,0,64,64,&dcTitleMem,0,0,SRCCOPY);
	CPoint fll;
	fll.x = (int)(clk.x-10)/32*32+10;
	fll.y = (int)(clk.y-4)/32*32+4+32;
	CBrush b(RGB(255,0,0));
	dx.FrameRect( CRect(fll.x,fll.y-32,fll.x+32,fll.y),&b);
	// Do not call CDialog::OnPaint() for painting messages
}

BOOL CMaterialDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();
	m_TexSlider.SetRange( 0, texMan->texCount-1 );
	static bool first  = false;
	if( !first )
	{
	  hdcScreen = GetDlgItem( IDC_TEXTURE )->GetDC( );
	  hbmScreen.CreateCompatibleBitmap( hdcScreen,TITLE_MAP_SIZE,TITLE_MAP_SIZE );
	  dcMem.CreateCompatibleDC( hdcScreen );
	  dcMem.SelectObject( hbmScreen );

	  hdcScreen = GetDlgItem( IDC_TITLE )->GetDC( );
	  bmTitle.CreateCompatibleBitmap( hdcScreen,64,64 );
	  dcTitleMem.CreateCompatibleDC( hdcScreen );
	  dcTitleMem.SelectObject( bmTitle );
	  // TODO: Add extra initialization here
	  changeTexImage( tmp );
	  showTitleBig();
	  first = true;   
	}
    //Load texture preset
	  //       
	optPath.Format("%s\%s.opt",ProgaOpts->ProgDir, ProgaOpts->RealMapName);
	//optPath.Replace("\","\\");
	LoadBuf(optPath);
	pInited = true;
	FillTileForm(0);
	FillMatList();
	SavedTile = 0;
	return TRUE;  // return TRUE unless you set the focus to a control	              // EXCEPTION: OCX Property Pages should return FALSE
}

void CMaterialDlg::OnLButtonDown(UINT nFlags, CPoint point) 
{
	// TODO: Add your message handler code here and/or call default
	CDialog::OnLButtonDown(nFlags, point);
	CString s;
	clk = point;
	point -= CPoint(9,9);
	int y;
	point.y = TITLE_MAP_SIZE-point.y;
    point.y -= 6;
	if( point.x > 0 && point.x < TITLE_MAP_SIZE && point.y > 0 && point.y < TITLE_MAP_SIZE  )
	{
		point.x /= SINGLE_TITLE_SIZE;
		point.y /= SINGLE_TITLE_SIZE;
	
		pos.x = point.x;
		pos.y = point.y;
		s.Format("%d,%d",point.x,point.y);
		tmp = 64*currentTex + 8*pos.y + pos.x;
		y = TITLE_MAP_SIZE-((pos.y+1)*SINGLE_TITLE_SIZE);
		showTitleBig();
		RedrawWindow( CRect(0,0,3000,3000) );
        FillTileForm(tmp);
		CString s = "";
		s.Format("  %d",tmp);
		SetDlgItemText(IDC_TILE_TMP,s);
	}
}

void CMaterialDlg::OnReleasedcaptureTexSlider(NMHDR* pNMHDR, LRESULT* pResult) 
{
	// TODO: Add your control notification handler code here
	if( GetDlgItem( IDC_TEX_SLIDER )->m_hWnd == pNMHDR->hwndFrom )
	{
		if( currentTex != (unsigned int)m_TexSlider.GetPos( ) )
		{
			currentTex = m_TexSlider.GetPos( );
			changeTexImage( currentTex );
		}
	}
	*pResult = 0;

}

void CMaterialDlg::changeTexImage( int texNum )
{
	int i,j;
	img =  texMan->GetTitleTexImage( texNum );

	for( j=0;j<TITLE_MAP_SIZE;j++)	
	for( i=0;i<TITLE_MAP_SIZE;i++)	
	{
		dcMem.SetPixel( i,j,RGB(img[i+TITLE_MAP_SIZE*j].r,img[i+TITLE_MAP_SIZE*j].g,img[i+TITLE_MAP_SIZE*j].b) );
	}
	RedrawWindow( CRect(0,0,3000,3000) );
}

void CMaterialDlg::OnClose() 
{
	// TODO: Add your message handler code here and/or call default
//	pParentWnd->RedrawWindow( CRect(0,0,300,300) );
//	CWnd::ShowWindow(SW_HIDE);
	CDialog::OnClose();

}

BOOL CMaterialDlg::Create( CWnd* pParentWnd ) 
{
	// TODO: Add your specialized code here and/or call the base class
	this->pParentWnd = pParentWnd;
	BOOL res = CDialog::Create(IDD, pParentWnd);
//	showTitleBig();
//	AfxMessageBox("as");
	return res;
}

void CMaterialDlg::OnOK() 
{
	// TODO: Add extra validation here
	currentTitle = tmp;	
	CDialog::OnOK();
}

bool  CMaterialDlg::execute()
{
	if( DoModal() ) return true;
	return false;
}

void CMaterialDlg::showTitleBig()
{
	int i,j;
	rgb a[64*64];
	memset(a,0,64*64*3);
	glBindTexture( GL_TEXTURE_2D , map->getTextures( tmp ) );
	glGetTexImage( GL_TEXTURE_2D , 0,GL_RGB, GL_UNSIGNED_BYTE, a );

	for( j=0;j<64;j++ )
	for( i=0;i<64;i++ )	
	{
		dcTitleMem.SetPixel( i,64-j,RGB(a[i+64*j].r,a[i+64*j].g,a[i+64*j].b) );
	}
}
/////////////////////////////////////////////////////////////////////////
////////////////
/////////////////////////////////////////////////////////////////////////

void CMaterialDlg::LoadBuf(const CString Path)
{
	FILE *file;
    
	file = fopen(Path,"r");
    if(file)
	{	 
	  fseek(file,0,SEEK_END);
	  BufLength = ftell(file);
	  if(BufLength>4)
	  {
        buf = new byte[BufLength];
	    fseek(file,0,SEEK_SET);
	    fread(buf,BufLength,1,file);
	  }
	  else
	  {
        BufLength = 0;
	  }
      fclose(file);
	  //Init...
      
	  byte h1 = 28, h2 = 225, h3 = 0, h4 = 0;
	  
	  memcpy(&h3,buf,1);
      memcpy(&h4,buf+2,1);
	  if((h3!=h1 || h4!=h2) && (BufLength>0))
	  {
        BufLength = 0;
		delete [] buf;
	  }
	  if(BufLength>=5)
	  {
	    memcpy(&MatCount,buf+4,1);
		byte LN;
		int k=0;
		for(int i=0;i<MatCount;i++)
		{
			memcpy(&LN,buf+6+k,1);
            k+=LN+2;
		}
		if(BufLength>k+9)
		{
			memcpy(&ZapCount,buf+9+k,2);
		}
	  }
	}
}
void CMaterialDlg::SaveBuf(const CString Path)
{
	FILE *file;

	file = fopen(Path,"w");
    if(file)
	{	 
	  fseek(file,0,SEEK_SET);
	  fwrite(buf,BufLength,1,file);
      fclose(file);
	}
}
CString CMaterialDlg::GetCaption(const byte Num)
{
  if(BufLength<4)
	  return "Error#1 Void array";
  unsigned int Cursor = 5;
  
  byte N, L, Zero=0;
  CString Rez="";
  char *tmp;
  bool ti = false;
  if(GetMatCount()>Num)
      for(int i=0;i<=Num;i++)
	  {
        memcpy(&N,buf+Cursor,1);
	    Cursor++;
        memcpy(&L,buf+Cursor,1);
		Cursor++;
        //Rez.SetLength( (int)(L+1) );
		if(ti)delete [] tmp;
        tmp = new char[L+1];
		ti = true;
		memcpy(tmp,buf+Cursor,L);
		Cursor+=L;
		memcpy(tmp+L,&Zero,1);
	  }
  Rez = CString(tmp,L+1);
  delete [] tmp;
  return Rez;
}
int CMaterialDlg::GetCode(const byte Num)
{
  if(BufLength<4)
	  return 0;
  unsigned int Cursor = 5;
  
  byte N, L, Zero=0;
  if(GetMatCount()>Num)
      for(int i=0;i<=Num;i++)
	  {
        memcpy(&N,buf+Cursor,1);
	    Cursor++;
        memcpy(&L,buf+Cursor,1);
		Cursor++;
        Cursor+=L;
	  }
  return N;
}
byte* CMaterialDlg::GetZap(const int Num)
{
    byte* Rez=new byte[4];
	if(Num<GetZapCount())
	{
	  if(BufLength>=5)
	  {
		byte LN;
		int k=0;
		for(int i=0;i<MatCount;i++)
		{
			memcpy(&LN,buf+6+k,1);
            k+=LN+2;
		}
		if(BufLength>k+9)
		{
			k+=9+2;
			for(int i=0;i<=Num;i++)
			{
				//byte a,b,c,d;
				memcpy(Rez+0,buf+k,1);
				k++;
				memcpy(Rez+1,buf+k,1);
				k++;
				memcpy(Rez+2,buf+k,1);
				k++;
				memcpy(Rez+3,buf+k,1);
				k++;
				
			}
		}
	  }
	}
	return Rez;
}
void CMaterialDlg::SetZap(const int Num, const byte *Zap)
{
	//byte *Til;
	int Len = 0;
	byte LN=0;
	int k=0;
	// 
	for(int i=0;i<MatCount;i++)
	{
		memcpy(&LN,buf+6+k,1);
        k+=LN+2;
	}
    // 
	k+=9+2+4*(Num);
	if(BufLength>k+5)
	{
		memcpy(buf+k+0,Zap+0,1);
		memcpy(buf+k+1,Zap+1,1);
		memcpy(buf+k+2,Zap+2,1);
		memcpy(buf+k+3,Zap+3,1);
	}
}

int CMaterialDlg::StrToInt(CString s)
{
	int Rez=0;
	for(int i=0;i< s.GetLength( );i++)
	{
		char c = s.GetAt(i);
        if((c>=48)&&(c<=57))
			Rez = Rez * 10 + c - 48;
	}

	return Rez;
}

void CMaterialDlg::GenerateOpt()
{
	byte *temp;
	int BL=0;
	WORD BLL = 1;
	int TC = GetTexCount() + 1;
	WORD tiles_num = TC*64;
	CString MatNam = "Default";
	byte NL = MatNam.GetLength();
	byte MC = 0;
	byte h1=28,h2=225;
	byte a=171,b=205,c=202,d=219;
	///
	delete [] buf;
	byte *Rez=new byte[23];
	BufLength = 23;
	memcpy(Rez,&h1,1);
	memcpy(Rez+1,&BL,1);
    memcpy(Rez+2,&h2,1);
    memcpy(Rez+3,&BL,1);
	//
	memcpy(Rez+4,&BL,1);
	memcpy(Rez+5,&a,1);
	memcpy(Rez+6,&b,1);
	memcpy(Rez+7,&c,1);
	memcpy(Rez+8,&d,1);
	memcpy(Rez+9,&BLL,2);
    memcpy(Rez+11,&MC,1);
	memcpy(Rez+12,&MC,1);
	memcpy(Rez+13,&MC,1);
	memcpy(Rez+14,&MC,1);
	char *t="*THEEND*";
	memcpy(Rez+15,t,8);
	//
	MatCount = 0;
	ZapCount = 1;
	Rez = AddMat(Rez,&BufLength,MC,MatNam);
	byte *r=new byte[4];
	memcpy(r+0,&MC,1);
	memcpy(r+1,&MC,1);
	memcpy(r+2,&MC,1);
	memcpy(r+3,&MC,1);
	for(int i = 0;i<tiles_num-1;i++)
	{
		byte *B = new byte[BufLength+4];
		AddTile(Rez, B, &BufLength, r);
		delete [] Rez;
		Rez = new byte[BufLength];
        memcpy(Rez,B,BufLength);
		delete [] B;
	}
    buf = Rez;
	  optPath.Format("%s\%s.NEW-GENERATED.opt",ProgaOpts->ProgDir, ProgaOpts->RealMapName);
	  SaveBuf(optPath);
      CString test;
	  test.Format("File: \r\n\"%s\"\r\nSaved successfully!",optPath);
	  MessageBox(test);
	delete [] r;
}

byte* CMaterialDlg::AddMat(byte *Buffer, int *Len, byte MatCod, CString Name)
{
	byte MC = 0,NL = 0; //MatCount, NameLength
	int TL = *Len; //Temp length
	char *N2 = new char[Name.GetLength()+1];
	for(int i=0;i<Name.GetLength();i++)
	{
		N2[i] = Name.GetAt(i);
	}
	*(N2+Name.GetLength()) = '\0';
    byte *temp = new byte[TL+2+Name.GetLength()];
	memcpy(&MC,Buffer+4,1);
	MC++;
	memcpy(temp,Buffer,4);
	memcpy(temp+4,&MC,1);
	int Cur = 5, BP = 0;//Cursor, BreakPoint
	for(int i=0;i<MC-1;i++)
	{
		Cur++;
		memcpy(&NL,Buffer+Cur,1);
		Cur++;
		Cur+=NL;
	}
	// ,     
	if(MC>1)
	{
	  memcpy(temp+5,Buffer+5,Cur-5);
	}
	//  
	BP = Cur;
	memcpy(temp+Cur,&MatCod,1);
	Cur++;
	NL = Name.GetLength();
	memcpy(temp+Cur,&NL,1);
	Cur++;
	memcpy(temp+Cur,N2,NL);
	Cur+=NL;
	delete [] N2;
    // .  ""
    memcpy(temp+Cur,Buffer+BP,TL-BP);
	delete [] Buffer;
	Buffer = new byte[TL+2+NL];
	memcpy(Buffer,temp,TL+2+NL);
	*Len += 2 + NL;
	delete [] temp;

	MatCount++;
	return Buffer;
}

void CMaterialDlg::AddTile(const byte *Buffer, byte *Dest, int *Len, byte *Tile)
{
    byte* Tmp=new byte[*Len+4];
	ZapCount++;
    ////////////////////

	byte LN;
	int k=0;
	for(int i=0;i<MatCount;i++)
	{
		memcpy(&LN,Buffer+6+k,1);
        k+=LN+2;
	}
	memcpy(Tmp,Buffer,k+9);//  
	k += 9;
	memcpy(Tmp+k,&ZapCount,2);
	k += 2;
	//k += 4*(ZapCount-2);
	if(ZapCount>2)
	{
	  memcpy(Tmp+k,Buffer+k,(ZapCount-2)*4);//  ,  
	  k += 4*(ZapCount-2);
	}
	if(ZapCount>1)
	{
	  memcpy(Tmp+k,Buffer+k,4);
	  k+=4;
	}
	memcpy(Tmp+k,Tile,4);
	k += 4;
	char *t="*THEEND*";
	memcpy(Tmp+k,t,8);
    k += 8;
    *Len+=4;
	///////////////////
	//delete [] Buffer;
	memcpy(Dest,Tmp,*Len);
	    
	//return Tmp;
}

void CMaterialDlg::SetCode(const byte Num, const byte Code)
{
  unsigned int Cursor = 5;
  
  byte N, L, Zero=0;
  if(GetMatCount()>Num)
  {
      for(int i=0;i<Num;i++)
	  {
        memcpy(&N,buf+Cursor,1);
	    Cursor++;
        memcpy(&L,buf+Cursor,1);
		Cursor++;
        Cursor+=L;
	  }
      memcpy(buf+Cursor,&Code,1);
  }
}

void CMaterialDlg::SetCaption(const byte Num, const CString Name)
{
  //      ;)
}

/////////////////////////////////////////////////////////////////////////
void CMaterialDlg::FillTileForm(int num)
{
		//Fill the form...
		byte *r, a, b, c, d;
		r = GetZap(num);
		memcpy(&a,r+0,1);
		memcpy(&b,r+1,1);
		memcpy(&c,r+2,1);
		memcpy(&d,r+3,1);

		Tile_a.Format("%d",a);
		Tile_b.Format("%d",b);
		Tile_c.Format("%d",c);
		Tile_d.Format("%d",d);

		delete [] r;
		UpdateData(TO);
}

void CMaterialDlg::OnBnClickedApplyTile()
{
  UpdateData(FROM);
  byte a,b,c,d;
  a = (byte)StrToInt(Tile_a);
  b = (byte)StrToInt(Tile_b);
  c = (byte)StrToInt(Tile_c);
  d = (byte)StrToInt(Tile_d);
  byte *r = new byte[4];
  memcpy(r+0,&a,1);
  memcpy(r+1,&b,1);
  memcpy(r+2,&c,1);
  memcpy(r+3,&d,1);
  SetZap(tmp,r);
  delete [] r;
}

void CMaterialDlg::OnBnClickedSaveOpts()
{
  if(BufLength>0)
  {
	optPath.Format("%s\%s.opt",ProgaOpts->ProgDir, ProgaOpts->RealMapName);
	SaveBuf(optPath);
    CString test;
	test.Format("File: \r\n\"%s\"\r\nSaved successfully!",optPath);
	MessageBox(test);
  }
}

void CMaterialDlg::OnBnClickedTestbutton()
{
  MessageBox(" ,   .        %)");
}

void CMaterialDlg::OnBnClickedGenerateOpts()
{
  GenerateOpt();
}


void CMaterialDlg::FillMatList()
{
  ////////////////////
  //    Clear list
  MList.ResetContent();
  /////////////////////
  // Add materials...
  for(int i=0;i<GetMatCount();i++)
  {
	  // ,    .    ;)
	  CString cap = GetCaption(i);
	  MList.AddString(cap);
  }
  /////////////////////
  //    Refreshing...
}

byte* CMaterialDlg::DelMat(byte *Buffer, int *Len, byte MatNum)
{
	byte MC = 0,NL = 0; //MatCount, NameLength
	int TL = *Len; //Temp length
	CString Name;
	memcpy(&MC,Buffer+4,1);
	MC--;
	int Cur = 5, BP = 0;//Cursor, BreakPoint
	for(int i=0;i<=MatNum;i++)
	{
		Cur++;
		memcpy(&NL,Buffer+Cur,1);
		Cur++;
		Cur+=NL;
	}
    byte *temp = new byte[TL-NL-2];

	memcpy(temp,Buffer,4);
	memcpy(temp+4,&MC,1);
	if(Cur>5)
	{
		memcpy(temp+5,Buffer+5,Cur-5-NL-2);
	}
	Cur-=NL+2;
    memcpy(temp+Cur,Buffer+Cur+NL+2,TL-NL-2);

	delete [] Buffer;
	Buffer = new byte[TL-2-NL];
	memcpy(Buffer,temp,TL-2-NL);
	*Len -= 2 + NL;
	delete [] temp;

	MatCount--;
	return Buffer;
}

void CMaterialDlg::OnBnClickedAddMat()
{
	if( MList.GetCount()<255 )
	{
		UpdateData(FROM);
		buf = AddMat(buf,&BufLength,(byte)(StrToInt(MatCode)),MatName);
		FillMatList();
	}
	else
	{
		MessageBox(",      1     ;)");
		MessageBox("  :      255 !");
		MessageBox(" ,   \"255\",     255   :)");
		MessageBox(" 1...");
		MessageBox(" 2...");
		MessageBox(" 3... ,  .    :P");
		MessageBox(" 4... ! :D");
	}
}

void CMaterialDlg::OnBnClickedApplyMat()
{
  if(MList.GetCount() > 0)
  {
    UpdateData(FROM);
    byte N = MList.GetCaretIndex();
	byte L = StrToInt(MatCode);
    buf = DelMat(buf,&BufLength,N);
	buf = AddMat(buf,&BufLength,L,MatName);
    FillMatList();
  }
  else
  {
	MessageBox("  !");
  }
}

void CMaterialDlg::OnBnClickedKillMat()
{
  if(MList.GetCount() > 0)
  {
    UpdateData(FROM);
    byte N = MList.GetCaretIndex();
    buf = DelMat(buf,&BufLength,N);
    FillMatList();
  }
  else
  {
	MessageBox("  ...");
  }
}

void CMaterialDlg::OnLbnSelchangeMatList()
{
  UpdateData(FROM);
  byte N = MList.GetCaretIndex();
  MatCode.Format("%d",GetCode(N));
  MatName = GetCaption(N);
  UpdateData(TO);
}

void CMaterialDlg::OnBnClickedPushTile()
{
  GetDlgItem(IDC_CALL_TILE)->EnableWindow(TRUE);
  UpdateData(FROM);
  byte a,b,c,d;
  a = (byte)StrToInt(Tile_a);
  b = (byte)StrToInt(Tile_b);
  c = (byte)StrToInt(Tile_c);
  d = (byte)StrToInt(Tile_d);
  SavedTile = 0;
  byte *r = new byte[4];
  memcpy(r+0,&a,1);
  memcpy(r+1,&b,1);
  memcpy(r+2,&c,1);
  memcpy(r+3,&d,1);

  memcpy(&SavedTile,r,4);
  delete [] r;
}

void CMaterialDlg::OnBnClickedCallTile()
{
  byte *r = new byte[4];
  memcpy(r,&SavedTile,4);
  SetZap(tmp,r);
  delete [] r;

  FillTileForm(tmp);
}

void CMaterialDlg::OnBnClickedOk()
{
	//  !
	if(BufLength>0)
	{
		optPath.Format("%s\%s.opt",ProgaOpts->ProgDir, ProgaOpts->RealMapName);
		SaveBuf(optPath);
	}	
	//  
	OnOK();
}
