#include "QtrNode.h"
// CQuadTree.h: interface for the CQuadTree class.
//
//////////////////////////////////////////////////////////////////////
#if !defined(AFX_CQUADTREE_H__8BA01ABB_4A75_40F9_BF73_75C76A4635FF__INCLUDED_)
#define AFX_CQUADTREE_H__8BA01ABB_4A75_40F9_BF73_75C76A4635FF__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
#include "stdafx.h"
#include "mprLandscape.h"

class MPRBASE_API CQuadTree  
{
	friend class CCamera;
public:
	void setNodeChanged( CQtrNode*, int, int );
	void vertexToDL( int,int );
	void wvertexToDL( int, int );
	void displayNodeNromals( CQtrNode* );
	void displayNormals();
	void drawNode_anim_tilesWireFrame( CQtrNode* );
	void drawNode_terrainWireFrame( CQtrNode* );
	void displayWireFrame();
	void displayBVolume( CQtrNode* );
	bool isBBoxVisible( CBountingVolume* );
	void UpdateFrustum();
	CQuadTree();
	CQuadTree( CmprLandscape* );
	~CQuadTree();

	void display( bool,bool,bool );
	void drawNode_anim_tiles( CQtrNode* );
	void drawNode_terrain( CQtrNode* );
	void buildNode( CQtrNode*,unsigned int,unsigned int,unsigned int,unsigned int);
	void changeLandscape( unsigned int,unsigned int,unsigned int );
	void changeNodeBBox( CQtrNode*,float,float,float );
	void rebuildChangedNodes();
	void updateDisplayLists( CQtrNode* );

	CQtrNode*	root;
};

#endif // !defined(AFX_CQUADTREE_H__8BA01ABB_4A75_40F9_BF73_75C76A4635FF__INCLUDED_)
