// ResManager.cpp: implementation of the CResManager class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "ResManager.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif


MPRBASE_API CResManager *resMan;
//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CResManager::CResManager()
{
	pData = 0;
	pSIndex = 0;
	sFileNames = _T("");
	sPathRes = _T("");
	sNameFileRes = _T("");

	SetPathRes(_T("D:\\Games\\ \\Res\\"));
}

CResManager::~CResManager()
{
	delete [] pData;
	delete [] pSIndex;

}

//  Res   
CFile *CResManager::Open(CString sNameFileRes)
{

	this->sNameFileRes = sNameFileRes;
	CString sFileName = sPathRes + sNameFileRes;
	CFileException e;
	CFile *pFile;
	pFile = new CFile;
	if (!pFile->Open(sFileName, CFile::modeRead/* || CFile::typeBinary*/, &e))
	{
		#ifdef _DEBUG
		afxDump << "File could not be opened " << e.m_cause << "\n";
		#endif
	}

	if (!pFile)
	{
		CString err;
		err.Format("The File %s not found", sFileName);
		MessageBox(NULL, err, "Error", MB_OK);
		return 0;
	}

return pFile;
}


CFile *CResManager::Open()
{

	CString sFileName = sPathRes + sNameFileRes;
	CFile *pFile = 0;
	pFile = new CFile;
	if (!pFile->Open(sFileName, CFile::modeRead /*|| CFile::typeBinary*/))
	{
		CString err;
		err.Format("The File %s not found", sFileName);
		MessageBox(NULL, err, "Error", MB_OK);
		return 0;
	}

return pFile;
}



//     Res 
BOOL CResManager::Load(CFile *pFile)
{

//	this->pFile = pFile;
	sNameFileRes = pFile->GetFileTitle();	
	pFile->Read(&hdr, sizeof(SResHeader));
//	pFile->SeekToBegin();
//	pData = new BYTE[hdr.dwDataSize];
//	pFile->Read(pData, hdr.dwDataSize);
	pFile->Seek(hdr.dwDataSize, CFile::begin);
	
	BYTE *pBuf = new BYTE[pFile->GetLength() - hdr.dwDataSize - hdr.dwStrSize];
	pFile->Read(pBuf, pFile->GetLength() - hdr.dwDataSize - hdr.dwStrSize);
	pSIndex = new SIndex[hdr.dwNumFile];
	BYTE *lp = pBuf;
	for (DWORD i = 0; i < hdr.dwNumFile; i++)
	{
		memcpy(&pSIndex[i].dwSignature, pBuf, sizeof(DWORD));
		pBuf += sizeof(DWORD);
		memcpy(&pSIndex[i].dwFileSize, pBuf, sizeof(DWORD));
		pBuf += sizeof(DWORD);
		memcpy(&pSIndex[i].dwFilePos, pBuf, sizeof(DWORD));
		pBuf += sizeof(DWORD);
		memcpy(&pSIndex[i].dwSignature2, pBuf, sizeof(DWORD));
		pBuf += sizeof(DWORD);
		memcpy(&pSIndex[i].wFileNameSize, pBuf, sizeof(WORD));
		pBuf += sizeof(WORD);
		memcpy(&pSIndex[i].dwFileNamePos, pBuf, sizeof(DWORD));
		pBuf += sizeof(DWORD);
	
	}
	
	delete [] lp;
	
	LPTSTR p = sFileNames.GetBuffer((int)hdr.dwStrSize);
	pFile->Read(p, hdr.dwStrSize);
	sFileNames.ReleaseBuffer();

	pFile->Close();

//	BYTE *pRes;
//	pRes = Get("basegipat007.mmp");


return true;
}

BOOL CResManager::Load(CString sFileRes)
{
	
	CFile *pFile = Open(sFileRes);
	if (pFile)
	{
		Load(pFile);
//		pFile->Close();
	}
	else
		return false;

return true;
}

BOOL CResManager::Load(LPBYTE lpData)
{

	memcpy(&hdr, lpData, sizeof(SResHeader));
	pData = new BYTE[hdr.dwDataSize];
	memcpy(pData, lpData, hdr.dwDataSize);
	lpData += hdr.dwDataSize;
	
	BYTE *pBuf = new BYTE[hdr.dwNumFile * sizeof(SIndex)];
	memcpy(pBuf, lpData, hdr.dwNumFile * sizeof(SIndex));	
	DWORD dw = hdr.dwNumFile * (sizeof(SIndex)-2);

	lpData += hdr.dwNumFile * (sizeof(SIndex)-2);
	pSIndex = new SIndex[hdr.dwNumFile];
	BYTE *lp = pBuf;
	for (DWORD i = 0; i < hdr.dwNumFile; i++)
	{
		memcpy(&pSIndex[i].dwSignature, pBuf, sizeof(DWORD));
		pBuf += sizeof(DWORD);
		memcpy(&pSIndex[i].dwFileSize, pBuf, sizeof(DWORD));
		pBuf += sizeof(DWORD);
		memcpy(&pSIndex[i].dwFilePos, pBuf, sizeof(DWORD));
		pBuf += sizeof(DWORD);
		memcpy(&pSIndex[i].dwSignature2, pBuf, sizeof(DWORD));
		pBuf += sizeof(DWORD);
		memcpy(&pSIndex[i].wFileNameSize, pBuf, sizeof(WORD));
		pBuf += sizeof(WORD);
		memcpy(&pSIndex[i].dwFileNamePos, pBuf, sizeof(DWORD));
		pBuf += sizeof(DWORD);
	
	}
	
	delete [] lp;
	
	LPTSTR p = sFileNames.GetBuffer((int)hdr.dwStrSize);
	ZeroMemory(p, hdr.dwStrSize);
	memcpy(p, lpData, hdr.dwStrSize);
	sFileNames.ReleaseBuffer();

return true;
}


BYTE *CResManager::Get(CString sName, BOOL b)
{

	if (sFileNames.Find(sName) == -1)
	{
		CString err;
		err.Format("The File %s not found", sName);
		MessageBox(NULL, err, "Error", MB_OK);
		return 0;
	}

	for (DWORD i = 0; i < hdr.dwNumFile; i++)
	{
//		int pos = pSIndex[i].dwFileNamePos;
		CString s = sFileNames.Mid(pSIndex[i].dwFileNamePos, pSIndex[i].wFileNameSize);
		if (sName.Compare(s) == 0)
			break;
	}

	BYTE *pRes = new BYTE[pSIndex[i].dwFileSize];
	
	if (b)
	{
		CFile *pFile = Open();
		pFile->Seek(pSIndex[i].dwFilePos, CFile::begin);
		pFile->Read(pRes, pSIndex[i].dwFileSize);	
		pFile->Close();
	}
	else
		memcpy(pRes, &pData[pSIndex[i].dwFilePos], pSIndex[i].dwFileSize);




return pRes;
}

BOOL CResManager::Get(CString sName, DWORD &dwFilePos, DWORD &dwFileSize)
{

	if (sFileNames.Find(sName) == -1)
	{
		CString err;
		err.Format("The File %s not found", sName);
		MessageBox(NULL, err, "Error", MB_OK);
		return false;
	}

	for (DWORD i = 0; i < hdr.dwNumFile; i++)
	{
//		int pos = pSIndex[i].dwFileNamePos;
		CString s = sFileNames.Mid(pSIndex[i].dwFileNamePos, pSIndex[i].wFileNameSize);
		if (sName.Compare(s) == 0)
			break;
	}

	dwFilePos = pSIndex[i].dwFilePos;
	dwFileSize = pSIndex[i].dwFileSize;
	ASSERT(dwFilePos);
	ASSERT(dwFileSize);

return true;
}
