// CTextureManager.cpp: implementation of the CTextureManager class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "TextureManager.h"
#include "LogFile.h"
#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif


MPRBASE_API CTextureManager *texMan;

rgb getRGBfromDWORD(unsigned short DWORD)
{
	rgb result;
	unsigned short SomeChannel;

	SomeChannel = DWORD & 0xF800;
	SomeChannel >>= 11;
	result.r = ( unsigned char )( SomeChannel * 255.0/31.0 );
	
	SomeChannel = DWORD & 0x07E0;
	SomeChannel >>= 5;
	result.g = ( unsigned char )( SomeChannel * 255.0/63.0 );

	SomeChannel = DWORD & 0x001F;
//	SomeChannel >>= 5;
	result.b = ( unsigned char )( SomeChannel * 255.0/31.0 );

	return result;
}

void extractColorsfrom2DWORD(unsigned short dw1, unsigned short dw2, unsigned char colors[4][4])
{

	colors[1][0] = (unsigned char)((dw1 & 0xC000) >> 14);
	colors[1][1] = (unsigned char)((dw1 & 0x3000) >> 12);
	colors[1][2] = (unsigned char)((dw1 & 0x0C00) >> 10);
	colors[1][3] = (unsigned char)((dw1 & 0x0300) >>  8);

	colors[0][0] = (unsigned char)((dw1 & 0x00C0) >>  6);
	colors[0][1] = (unsigned char)((dw1 & 0x0030) >>  4);
	colors[0][2] = (unsigned char)((dw1 & 0x000C) >>  2);
	colors[0][3] = (unsigned char)((dw1 & 0x0003) >>  0);

	colors[3][0] = (unsigned char)((dw2 & 0xC000) >> 14);
	colors[3][1] = (unsigned char)((dw2 & 0x3000) >> 12);
	colors[3][2] = (unsigned char)((dw2 & 0x0C00) >> 10);
	colors[3][3] = (unsigned char)((dw2 & 0x0300) >>  8);

	colors[2][0] = (unsigned char)((dw2 & 0x00C0) >>  6);
	colors[2][1] = (unsigned char)((dw2 & 0x0030) >>  4);
	colors[2][2] = (unsigned char)((dw2 & 0x000C) >>  2);
	colors[2][3] = (unsigned char)((dw2 & 0x0003) >>  0);
}
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
CTextureManager::CTextureManager()
{
}
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
CTextureManager::~CTextureManager()
{
	for( int i=0;i<texCount;i++ )
	delete textures[i];
	delete textures;
}
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
void CTextureManager::Load( CString path,GLuint*id/*,prgProc	proc */)
{
	GLuint ID;
	mmpHeader Header;
	unsigned char *data;
	unsigned int size=0,offset=0,i=0,j=0,sx,sy;
	FILE *f = fopen( path,"rb" );
	if(!f) 
	{
		CString str;
		str.Format("TextureManager:%s not found",path);
		Log->AddLog( str,CLogFile::modeFail);
	}
	fread(&Header,sizeof(mmpHeader),1,f);
	glGenTextures(1, &ID );

	glBindTexture(GL_TEXTURE_2D, ID );

	glTexParameteri(GL_TEXTURE_2D,GL_GENERATE_MIPMAP_SGIS,GL_TRUE);
	glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_S, GL_REPEAT);
	glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_T, GL_REPEAT);
	glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_LINEAR_MIPMAP_LINEAR);
	glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_LINEAR);
	glTexEnvf(GL_TEXTURE_ENV,GL_TEXTURE_ENV_MODE,GL_MODULATE);
		size = ((Header.width+3)/4)*((Header.height+3)/4)*8; 
		data = new unsigned char[size];
		fread(data,1,size,f);
		//   ...
		const GLubyte * pExtString = glGetString(GL_VENDOR);
		Log->AddLog( "GL_VENDOR", CLogFile::modeOk );
		Log->AddLog( pExtString, CLogFile::modeOk );
		pExtString = glGetString(GL_RENDERER);
		Log->AddLog( "GL_RENDERER", CLogFile::modeOk );
		Log->AddLog( pExtString, CLogFile::modeOk );
		pExtString = glGetString(GL_VERSION);
		Log->AddLog( "GL_VERSION", CLogFile::modeOk );
		Log->AddLog( pExtString, CLogFile::modeOk );
		pExtString = glGetString(GL_EXTENSIONS);
		Log->AddLog( "GL_EXTENSIONS", CLogFile::modeOk );
		Log->AddLog( pExtString, CLogFile::modeOk );
		//End of test
		if (GLEW_ARB_texture_compression) 
		{ 
			glCompressedTexImage2DARB( GL_TEXTURE_2D, i, GL_COMPRESSED_RGBA_S3TC_DXT1_EXT, Header.width, Header.height, 0, size, data); 
		}
		else
		{
			MessageBox(NULL,"      - !!!! :D","!!",1);
		}
		Header.width /= 2;
		Header.height/= 2;
		delete []data;
		data = new unsigned char[512*512*3];
		glGetTexImage( GL_TEXTURE_2D,0,GL_RGB,GL_UNSIGNED_BYTE,data );
		glDeleteTextures(1,&ID);
		unsigned char tmp[64*64*3];
		glGenTextures(64,id);
		for(i=0;i<8;i++)
		for(j=0;j<8;j++)
		{
			for( sy=0;sy<64;sy++ )
			for( sx=0;sx<64;sx++ )
			{
				tmp[3*(sx+64*sy)+0] = data[3*(64*i+sx+(64*(7-j)+(63-sy))*512)+0];
				tmp[3*(sx+64*sy)+1] = data[3*(64*i+sx+(64*(7-j)+(63-sy))*512)+1];
				tmp[3*(sx+64*sy)+2] = data[3*(64*i+sx+(64*(7-j)+(63-sy))*512)+2];
			}
			glBindTexture( GL_TEXTURE_2D, id[i+8*j] );
				glTexParameteri(GL_TEXTURE_2D,GL_GENERATE_MIPMAP_SGIS,GL_TRUE);
				glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_S, GL_CLAMP_TO_EDGE);
				glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_T, GL_CLAMP_TO_EDGE);
				glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_LINEAR_MIPMAP_LINEAR);
				glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_LINEAR);
				glTexEnvf(GL_TEXTURE_ENV,GL_TEXTURE_ENV_MODE,GL_MODULATE);
			glTexImage2D( GL_TEXTURE_2D,0,GL_RGB,64,64,0,GL_RGB,GL_UNSIGNED_BYTE,tmp );
			//proc(PT_LOAD_TITLE,&i);
		}
	delete []data;
	fclose(f);

}
/////////////////////////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
void CTextureManager::Load( BYTE* data,GLuint*id/*,prgProc	proc */)
{
/*	mmpHeader mmPHeader;
	unsigned short dwcolors[4];
	rgb rgbcolors[4], *colorMap;
	unsigned char colors[4][4];
	unsigned short dw1, dw2;

	FILE *f = fopen(path.GetBuffer(0),"rb");
	if(!f) {Log->AddLog("texture file not floud" + path,CLogFile::modeFail) ;}

	fread(&mmPHeader,1,sizeof(mmpHeader),f);
	colorMap = (rgb*)calloc( mmPHeader.width * mmPHeader.height, sizeof(rgb));
	for(int j = 0 ; j < (int)(mmPHeader.height/4) ; j++)
	for(int i = 0 ; i < (int)(mmPHeader.width /4) ; i++)
	{
		fread(&dwcolors[0],1,sizeof(unsigned short), f);
		fread(&dwcolors[1],1,sizeof(unsigned short), f);
		fread(&dw1,1,2,f);
		fread(&dw2,1,2,f);
		rgbcolors[0] = getRGBfromDWORD( dwcolors[0] );
		rgbcolors[1] = getRGBfromDWORD( dwcolors[1] );

		if(dwcolors[0] > dwcolors[1])
		{
			rgbcolors[2].r = (unsigned char)(2.0/3.0 * rgbcolors[0].r + 1.0/3.0 * rgbcolors[1].r + 0.0);
			rgbcolors[2].g = (unsigned char)(2.0/3.0 * rgbcolors[0].g + 1.0/3.0 * rgbcolors[1].g + 0.0);
			rgbcolors[2].b = (unsigned char)(2.0/3.0 * rgbcolors[0].b + 1.0/3.0 * rgbcolors[1].b + 0.0);

			rgbcolors[3].r = (unsigned char)(1.0/3.0 * rgbcolors[0].r + 2.0/3.0 * rgbcolors[1].r + 0.0);
			rgbcolors[3].g = (unsigned char)(1.0/3.0 * rgbcolors[0].g + 2.0/3.0 * rgbcolors[1].g + 0.0);
			rgbcolors[3].b = (unsigned char)(1.0/3.0 * rgbcolors[0].b + 2.0/3.0 * rgbcolors[1].b + 0.0);
		}
		else
		{
			rgbcolors[2].r = (unsigned char)((rgbcolors[0].r + rgbcolors[1].r)/2.0);
			rgbcolors[2].g = (unsigned char)((rgbcolors[0].g + rgbcolors[1].g)/2.0);
			rgbcolors[2].b = (unsigned char)((rgbcolors[0].b + rgbcolors[1].b)/2.0);
			rgbcolors[3].r = 0;
			rgbcolors[3].g = 0;
			rgbcolors[3].b = 0;

		}

		extractColorsfrom2DWORD( dw1, dw2, colors );

		colorMap[ 4 * i + 0 + ( mmPHeader.height - 1  - (4 * j + 0) ) * mmPHeader.width ] = rgbcolors[colors[0][3]];
		colorMap[ 4 * i + 0 + ( mmPHeader.height - 1  - (4 * j + 1) ) * mmPHeader.width ] = rgbcolors[colors[1][3]];
		colorMap[ 4 * i + 0 + ( mmPHeader.height - 1  - (4 * j + 2) ) * mmPHeader.width ] = rgbcolors[colors[2][3]];
		colorMap[ 4 * i + 0 + ( mmPHeader.height - 1  - (4 * j + 3) ) * mmPHeader.width ] = rgbcolors[colors[3][3]];

		colorMap[ 4 * i + 1 + ( mmPHeader.height - 1  - (4 * j + 0) ) * mmPHeader.width ] = rgbcolors[colors[0][2]];
		colorMap[ 4 * i + 1 + ( mmPHeader.height - 1  - (4 * j + 1) ) * mmPHeader.width ] = rgbcolors[colors[1][2]];
		colorMap[ 4 * i + 1 + ( mmPHeader.height - 1  - (4 * j + 2) ) * mmPHeader.width ] = rgbcolors[colors[2][2]];
		colorMap[ 4 * i + 1 + ( mmPHeader.height - 1  - (4 * j + 3) ) * mmPHeader.width ] = rgbcolors[colors[3][2]];

		colorMap[ 4 * i + 2 + ( mmPHeader.height - 1  - (4 * j + 0) ) * mmPHeader.width ] = rgbcolors[colors[0][1]];
		colorMap[ 4 * i + 2 + ( mmPHeader.height - 1  - (4 * j + 1) ) * mmPHeader.width ] = rgbcolors[colors[1][1]];
		colorMap[ 4 * i + 2 + ( mmPHeader.height - 1  - (4 * j + 2) ) * mmPHeader.width ] = rgbcolors[colors[2][1]];
		colorMap[ 4 * i + 2 + ( mmPHeader.height - 1  - (4 * j + 3) ) * mmPHeader.width ] = rgbcolors[colors[3][1]];
	
		colorMap[ 4 * i + 3 + ( mmPHeader.height - 1  - (4 * j + 0) ) * mmPHeader.width ] = rgbcolors[colors[0][0]];
		colorMap[ 4 * i + 3 + ( mmPHeader.height - 1  - (4 * j + 1) ) * mmPHeader.width ] = rgbcolors[colors[1][0]];
		colorMap[ 4 * i + 3 + ( mmPHeader.height - 1  - (4 * j + 2) ) * mmPHeader.width ] = rgbcolors[colors[2][0]];
		colorMap[ 4 * i + 3 + ( mmPHeader.height - 1  - (4 * j + 3) ) * mmPHeader.width ] = rgbcolors[colors[3][0]];
	}	
	fclose( f );
	glEnable(GL_TEXTURE_2D);
	rgb *ct = (rgb *)calloc(4096,sizeof(rgb));
	glGenTextures(64, id );
	for(int j1=0;j1<8;j1++)
	for(int i1=0;i1<8;i1++)
	{
		for(int j2=0;j2<64;j2++)
		for(int i2=0;i2<64;i2++)
		{
			ct[ i2 + 64 * j2 ] = colorMap[64 * i1 + i2 + 64 * 512 * j1 + 512 * j2];
		}


		glBindTexture(GL_TEXTURE_2D, id[i1+j1*8]);

		glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_S, GL_CLAMP_TO_EDGE);
		glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_T, GL_CLAMP_TO_EDGE);
		glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_LINEAR_MIPMAP_NEAREST);
		glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_LINEAR);

		glTexEnvf(GL_TEXTURE_ENV,GL_TEXTURE_ENV_MODE,GL_MODULATE);
		int error;
		error = gluBuild2DMipmaps(GL_TEXTURE_2D,3,64,64,GL_RGB,GL_UNSIGNED_BYTE,ct);
		if(error != 0)
		{
			free(colorMap);
			free(ct);
			return;
		}
		proc(PT_LOAD_TITLE,&i1);
	}
	free(colorMap);
	free(ct);
	return;
*/
}
/////////////////////////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////////////////////////
rgb* CTextureManager::GetTexImage( char* lpszFileName, unsigned int *width, unsigned int *height )
{
	unsigned int i,j;
	CString str;
	mmpHeader mmPHeader;
	rgb	*colorMap;
	FILE *f = fopen( lpszFileName,"rb" );
	if(!f) return NULL;
	fread(&mmPHeader,sizeof(mmPHeader),1,f);
	colorMap = unpack( mmPHeader, f );
	fclose( f );
	rgb* bitMap;
	*width = mmPHeader.width;
	*height= mmPHeader.height;
	bitMap = (rgb*)calloc(mmPHeader.height*mmPHeader.width,sizeof(rgb));
	for( j = 0 ; j < mmPHeader.height ; j++)
	for( i = 0 ; i < mmPHeader.width  ; i++)
	{
		bitMap[i + *width*j] = colorMap[i + *width*j];
	}
	return bitMap;
}
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////

void CTextureManager::loadTexImage( int pos, CString tex )
{
	mmpHeader mmPHeader;
	rgb *colorMap;
	GLuint tID;

	FILE *f = fopen(tex,"rb");
	if(!f) {exit(-1);}

	fread(&mmPHeader,1,sizeof(mmpHeader),f);
	colorMap = unpack( mmPHeader, f );
	fclose( f );
	glEnable(GL_TEXTURE_2D);
	rgb *ct = (rgb *)calloc(262144,sizeof(rgb));
	glGenTextures( 1, &tID );
		for(int j2=0;j2<512;j2++)
		for(int i2=0;i2<512;i2++)
		{
			ct[ i2 + 512 * j2 ] = colorMap[ i2 + 512*(511-j2) ];
		}


		glBindTexture(GL_TEXTURE_2D, tID );

		glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_S, GL_CLAMP_TO_EDGE);
		glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_T, GL_CLAMP_TO_EDGE);
		glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_LINEAR_MIPMAP_NEAREST);
		glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_LINEAR);

		glTexEnvf(GL_TEXTURE_ENV,GL_TEXTURE_ENV_MODE,GL_MODULATE);
		gluBuild2DMipmaps(GL_TEXTURE_2D,3,512,512,GL_RGB,GL_UNSIGNED_BYTE,ct);
		
		textures[ pos ] = new rgb[256*256];
		glGetTexImage(  GL_TEXTURE_2D,1,GL_RGB,GL_UNSIGNED_BYTE,textures[ pos ]);
	free(colorMap);
	free(ct);
	return;

}


void CTextureManager::setTexCount( int count )
{ 
			texCount = count;
//			if( textures != NULL )
//			delete []textures;
			textures = new rgb*[ texCount];
};

rgb* CTextureManager::GetTitleTexImage( int pos )
{
	return textures[pos];
}

rgb* CTextureManager::unpack( mmpHeader mmPHeader,FILE* f )
{
	rgb* colorMap = (rgb*)calloc( mmPHeader.width * mmPHeader.height, sizeof(rgb));
	rgb	rgbcolors[4];
	unsigned short dwcolors[4],dw1,dw2;
	unsigned char colors[4][4];
	for(int j = 0 ; j < (int)(mmPHeader.height/4) ; j++)
	for(int i = 0 ; i < (int)(mmPHeader.width /4) ; i++)
	{
		fread(&dwcolors[0],1,sizeof(unsigned short), f);
		fread(&dwcolors[1],1,sizeof(unsigned short), f);
		fread(&dw1,1,2,f);
		fread(&dw2,1,2,f);
		rgbcolors[0] = getRGBfromDWORD( dwcolors[0] );
		rgbcolors[1] = getRGBfromDWORD( dwcolors[1] );

		if(dwcolors[0] > dwcolors[1])
		{
			rgbcolors[2].r = (unsigned char)(2.0/3.0 * rgbcolors[0].r + 1.0/3.0 * rgbcolors[1].r + 0.0);
			rgbcolors[2].g = (unsigned char)(2.0/3.0 * rgbcolors[0].g + 1.0/3.0 * rgbcolors[1].g + 0.0);
			rgbcolors[2].b = (unsigned char)(2.0/3.0 * rgbcolors[0].b + 1.0/3.0 * rgbcolors[1].b + 0.0);

			rgbcolors[3].r = (unsigned char)(1.0/3.0 * rgbcolors[0].r + 2.0/3.0 * rgbcolors[1].r + 0.0);
			rgbcolors[3].g = (unsigned char)(1.0/3.0 * rgbcolors[0].g + 2.0/3.0 * rgbcolors[1].g + 0.0);
			rgbcolors[3].b = (unsigned char)(1.0/3.0 * rgbcolors[0].b + 2.0/3.0 * rgbcolors[1].b + 0.0);
		}
		else
		{
			rgbcolors[2].r = (unsigned char)((rgbcolors[0].r + rgbcolors[1].r)/2.0);
			rgbcolors[2].g = (unsigned char)((rgbcolors[0].g + rgbcolors[1].g)/2.0);
			rgbcolors[2].b = (unsigned char)((rgbcolors[0].b + rgbcolors[1].b)/2.0);
			rgbcolors[3].r = 0;
			rgbcolors[3].g = 0;
			rgbcolors[3].b = 0;

		}

		extractColorsfrom2DWORD( dw1, dw2, colors );

		colorMap[ 4 * i + 0 + ( mmPHeader.height - 1  - (4 * j + 0) ) * mmPHeader.width ] = rgbcolors[colors[0][3]];
		colorMap[ 4 * i + 0 + ( mmPHeader.height - 1  - (4 * j + 1) ) * mmPHeader.width ] = rgbcolors[colors[1][3]];
		colorMap[ 4 * i + 0 + ( mmPHeader.height - 1  - (4 * j + 2) ) * mmPHeader.width ] = rgbcolors[colors[2][3]];
		colorMap[ 4 * i + 0 + ( mmPHeader.height - 1  - (4 * j + 3) ) * mmPHeader.width ] = rgbcolors[colors[3][3]];

		colorMap[ 4 * i + 1 + ( mmPHeader.height - 1  - (4 * j + 0) ) * mmPHeader.width ] = rgbcolors[colors[0][2]];
		colorMap[ 4 * i + 1 + ( mmPHeader.height - 1  - (4 * j + 1) ) * mmPHeader.width ] = rgbcolors[colors[1][2]];
		colorMap[ 4 * i + 1 + ( mmPHeader.height - 1  - (4 * j + 2) ) * mmPHeader.width ] = rgbcolors[colors[2][2]];
		colorMap[ 4 * i + 1 + ( mmPHeader.height - 1  - (4 * j + 3) ) * mmPHeader.width ] = rgbcolors[colors[3][2]];

		colorMap[ 4 * i + 2 + ( mmPHeader.height - 1  - (4 * j + 0) ) * mmPHeader.width ] = rgbcolors[colors[0][1]];
		colorMap[ 4 * i + 2 + ( mmPHeader.height - 1  - (4 * j + 1) ) * mmPHeader.width ] = rgbcolors[colors[1][1]];
		colorMap[ 4 * i + 2 + ( mmPHeader.height - 1  - (4 * j + 2) ) * mmPHeader.width ] = rgbcolors[colors[2][1]];
		colorMap[ 4 * i + 2 + ( mmPHeader.height - 1  - (4 * j + 3) ) * mmPHeader.width ] = rgbcolors[colors[3][1]];
	
		colorMap[ 4 * i + 3 + ( mmPHeader.height - 1  - (4 * j + 0) ) * mmPHeader.width ] = rgbcolors[colors[0][0]];
		colorMap[ 4 * i + 3 + ( mmPHeader.height - 1  - (4 * j + 1) ) * mmPHeader.width ] = rgbcolors[colors[1][0]];
		colorMap[ 4 * i + 3 + ( mmPHeader.height - 1  - (4 * j + 2) ) * mmPHeader.width ] = rgbcolors[colors[2][0]];
		colorMap[ 4 * i + 3 + ( mmPHeader.height - 1  - (4 * j + 3) ) * mmPHeader.width ] = rgbcolors[colors[3][0]];
	}	
	return colorMap;
}