#if !defined (__GAME_TYPES__)
#define		  __GAME_TYPES__

#include <assert.h>
#include "..\math\mathlib.h"
#pragma pack(1)
enum ETERR_OBJ_TYPE
{
	TOT_UNDEF = 0,					// Unidentified
	TOT_TERRAIN = 1,				// Base terrain type
	TOT_WATER_NOTEXTURE = 2,		// Water without texture
	TOT_WATER = 3,					// Textured water
	TOT_GRASS = 4					// Textured grass
};
#pragma pack()

typedef struct {
vec3 normal;
float dist;
} plane_t;

struct SSectVert
{
	char sbXOff, sbYOff;
	unsigned short usZ;
	unsigned int uNormal;
};
struct rgb
{
	unsigned char r,g,b;
};
/*struct	mapPoint
{
	char sbXOff, sbYOff;						// offsets from regular cells positions
	unsigned short usZ;							// height of the vertex
	unsigned int uNormal;
};*/

struct STileAnimInfo
{
	WORD wAnimatedTileIndex;					// Index of animated tile
	WORD wAnimationPhases;						// Number of animation phases
};

struct SMapObject
{
	ETERR_OBJ_TYPE eType;						// Type of object
	float fpR, fpG, fpB;						// Diffuse color of object
	float fpOpacity;							// Opacity of object
	float fpSelfIllum;							// Self illumination of object
	float fpWaveMultiplier;
	float fpWarpSpeed;
	float fpReserved[ 3 ];
};
struct texInf
{
	unsigned char Id;
	unsigned char angle;
};
struct mmpHeader
{
	char mmpId[4];
	unsigned int	width;
	unsigned int	height;
	unsigned int	mipmapcount;
	char			compressionType[4];
	unsigned int	unimportant[14];
};
struct	tu_tv
{ 
	float	Matrix[3][3][4];
};

const float FP_XFLOOR_EPS = 1e-5f;
inline int xfloor( float fpVar )
{
	int nRet = int( fpVar );
	if ( fabs( float( nRet ) - fpVar ) > 1.f - FP_XFLOOR_EPS )
	{
		fpVar += fpVar * FP_XFLOOR_EPS;
		nRet = int( fpVar );
	}
	return nRet;
}


inline UINT32 GetNormal( float fpX, float fpY, float fpZ )
{
	assert( fpX >= -1.0f && fpX <= 1.0f );
	assert( fpY >= -1.0f && fpY <= 1.0f );
	assert( fpZ >= 0.0f && fpZ <= 1.0f );
	return	( unsigned( xfloor( fpZ * 1000.f ) ) << 22 ) |
			( unsigned( xfloor( fpX * 1000.f + 1000.f ) ) << 11 ) |
			unsigned( xfloor( fpY * 1000.f + 1000.f ) );


}
inline void GetNormal( UINT32 uNormal, float& fpX, float& fpY, float& fpZ )
{
	fpZ = float( uNormal >> 22 ) / 1000.f;
	fpX = ( float( ( uNormal >> 11 ) & 0x7FF ) - 1000.f ) / 1000.f;
	fpY = ( float( uNormal & 0x7FF ) - 1000.f ) / 1000.f;
}




#endif