// CmprLandscape.cpp: implementation of the CmprLandscape class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "mprLandscape.h"
#include "Texturemanager.h"
#include "LogFile.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

CmprLandscape*	map;
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
CmprLandscape::CmprLandscape()
{
	section = new mprSection( );
	map = this;
}
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
CmprLandscape::~CmprLandscape()
{

	glDeleteTextures( Header.dwTextures*64, textures );
	delete []textures;
	delete []HeightMap;
	delete []WaterMap;
	delete []wTiles;
	delete []wAnimTiles;
	delete []wObjectID ;
	delete []MiniMapImage;
	delete   section;
	delete	tree;
}
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
void CmprLandscape::Load(/* prgProc	proc */)
{
	resMan->SetPathRes( ProgaOpts->GameDir );
//	resMan->Load(CString("res\\resource.res"));
	unsigned int offsetx,offsety,i,j,sx,sy;
	CString mp;
	mp.Format( "%s.mp",ProgaOpts->RealMapName );
	Header.Read();
	iMapSizeX = Header.dwXSectorsCount*32+1;
	iMapSizeY = Header.dwYSectorsCount*32+1;
	iMapTitleSizeX = Header.dwXSectorsCount*16;
	iMapTitleSizeY = Header.dwYSectorsCount*16;
	textures = new GLuint[ Header.dwTextures*64 ];
	CString s;
	texMan->setTexCount( Header.dwTextures );
	//proc(PT_SET_TITLE_COUNT,&(Header.dwTextures));
	for(i=0;i<Header.dwTextures;i++)
	{
		s.Format( "%s\mpr\\%s%.3d.mmp",ProgaOpts->ProgDir,ProgaOpts->RealMapName.GetBufferSetLength(ProgaOpts->RealMapName.GetLength()),i );
		texMan->Load( s,textures + 64*i/*,proc */);
		texMan->loadTexImage( i, s );
	}

	s.Format( "%s\mpr\\%smap.mmp",ProgaOpts->ProgDir,ProgaOpts->RealMapName.GetBufferSetLength(ProgaOpts->RealMapName.GetLength()),i );
	MiniMapImage = texMan->GetTexImage( s.GetBuffer(0), &MiniMapX,&MiniMapY );
	HeightMap = new SSectVert[ (iMapSizeX+1)*(iMapSizeY+1) ];
	WaterMap  = new SSectVert[ (iMapSizeX+1)*(iMapSizeY+1) ];
	wTiles	  = new WORD[ iMapTitleSizeX*iMapTitleSizeY ];
	wAnimTiles= new WORD[ iMapTitleSizeX*iMapTitleSizeY ];
	wObjectID = new WORD[ iMapTitleSizeX*iMapTitleSizeY ];
	CString csSecNumber;
	for(i=0;i<Header.dwXSectorsCount;i++ )
	for(j=0;j<Header.dwYSectorsCount;j++ )
	{
		offsetx = i*32;
		offsety = j*32;
		csSecNumber.Format( "%03d%03d.sec",i,j );
		section->Read( ProgaOpts->RealMapName + csSecNumber/*,proc*/);
		for( sx = 0;sx<33;sx++ )
		for( sy = 0;sy<33;sy++ )
		{
			HeightMap[ offsetx+sx+(offsety+sy)*iMapSizeX ] = section->map_points[ sx+33*sy ];
			if( section->water )
			WaterMap [ offsetx+sx+(offsety+sy)*iMapSizeX ] = section->water_points[ sx+33*sy ];
		}
		for( sx = 0;sx<16;sx++ )
		for( sy = 0;sy<16;sy++ )
		{
			wTiles    [ i*16 + sx + (j*16+sy)*Header.dwXSectorsCount*16 ] = section->mapTextures  [ sx+16*sy ];
			wAnimTiles[ i*16 + sx + (j*16+sy)*Header.dwXSectorsCount*16 ] = section->waterTextures[ sx+16*sy ];
			wObjectID [ i*16 + sx + (j*16+sy)*Header.dwXSectorsCount*16 ] = section->waterAllow   [ sx+16*sy ];
		}
	}	

	tree = new CQuadTree( this );
}
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
void CmprLandscape::display( bool showLand,bool showWater,bool showObjects )
{
	tree->display( showLand, showWater, showObjects );
}

void CmprLandscape::Save( CString csMmapName ,CString EIgamedir,CString SelfDir )
{
	unsigned int i,j,offsetx,offsety,sx,sy;
	bool	isWater;
	CString	csSecNumber;
	for(i=0;i<Header.dwXSectorsCount;i++ )
	for(j=0;j<Header.dwYSectorsCount;j++ )
	{
		offsetx = i*32;
		offsety = j*32;
		csSecNumber.Format( "%03d%03d.sec",i,j );
		for( sx = 0;sx<33;sx++ )
		for( sy = 0;sy<33;sy++ )
		{
			section->map_points[ sx+33*sy ]   = HeightMap[ offsetx+sx+(offsety+sy)*iMapSizeX ];
			section->water_points[ sx+33*sy ] = WaterMap [ offsetx+sx+(offsety+sy)*iMapSizeX ];
		}
		isWater= false;
		for( sx = 0;sx<16;sx++ )
		for( sy = 0;sy<16;sy++ )
		{
			if( wObjectID[ i*16 + sx + (j*16+sy)*Header.dwXSectorsCount*16 ] != 0xffff ) isWater = true;
			section->mapTextures[ sx+16*sy ]   = wTiles[ i*16 + sx + (j*16+sy)*Header.dwXSectorsCount*16 ];
			section->waterTextures[ sx+16*sy ] = wAnimTiles[ i*16 + sx + (j*16+sy)*Header.dwXSectorsCount*16 ];
			section->waterAllow[ sx+16*sy ]    = wObjectID[ i*16 + sx + (j*16+sy)*Header.dwXSectorsCount*16 ];
		}
		section->water = isWater?0x3:0x0;
		section->Write( csMmapName + csSecNumber );
	}
}

unsigned short CmprLandscape::getHMapZ( unsigned int x, unsigned int y )
{
	if( x >= 0 &&
		x <= iMapSizeX &&
		y >= 0 &&
		y <= iMapSizeY)
		return HeightMap[ x + iMapSizeX*y ].usZ;
	else return HeightMap[ 0 ].usZ;
}

unsigned short CmprLandscape::getWMapZ( unsigned int x, unsigned int y )
{
	if( x >= 0 &&
		x <= iMapSizeX &&
		y >= 0 &&
		y <= iMapSizeY)
		return WaterMap[ x + iMapSizeX*y ].usZ;
	else return WaterMap[ 0 ].usZ;
}

void CmprLandscape::setHMapZ(unsigned int x,unsigned int y,unsigned int z)
{
	if( x > 0 && x < iMapSizeX && y > 0 && y < iMapSizeX )
	{
		HeightMap[ x + iMapSizeX*y ].usZ = min( z, 65535 );
		updateNormal( x,y );
		tree->changeLandscape( x,y,z );
	}
}

void CmprLandscape::setWMapZ(unsigned int x,unsigned int y,unsigned int z)
{
	if( x > 0 && x < iMapSizeX && y > 0 && y < iMapSizeX )
	{
		WaterMap[ x + iMapSizeX*y ].usZ = min( z, 65535 );
		updateNormal( x,y );
		tree->changeLandscape( x,y,z );
	}
}

void CmprLandscape::refresh()
{
	tree->rebuildChangedNodes();
}


/////////////////////////////////////////////////////////////////////////////////////////
vec3 CmprLandscape::findSelect( vec3 ViewVect )
{
	distance = 1.0;
	vec3 res;
	crossAABB( ViewVect, tree->root,&res );
	return res;
}


void CmprLandscape::crossAABB(	vec3 ViewVect, CQtrNode* node,vec3* res )
{
	float temp,x,y,z;
	temp = ( node->points[0].y - cam.y )/ViewVect.y;
	if( temp > 0 )
	{
		x = cam.x + temp*ViewVect.x;
		z = cam.z + temp*ViewVect.z;
		if( node->points[0].x < x && x < node->points[5].x && 
			node->points[0].z*getvZoom()/65536.0f < z && z < node->points[5].z*getvZoom()/65536.0f )
		{
			node->color[1] = 0;node->color[2] = 0;
			if( node->childs )
			{
				crossAABB( ViewVect,node->childs  ,res );
				crossAABB( ViewVect,node->childs+1,res );
				crossAABB( ViewVect,node->childs+2,res );
				crossAABB( ViewVect,node->childs+3,res );
			}
			else
			{
				findIntersect( node,ViewVect,res );
			}
			return;
		}
	}

	temp = ( node->points[1].x - cam.x )/ViewVect.x;
	if( temp > 0 )
	{
		y = cam.y + temp*ViewVect.y;
		z = cam.z + temp*ViewVect.z;
		if( node->points[1].y < y && y < node->points[6].y && 
			node->points[1].z*getvZoom()/65536.0f < z && z < node->points[6].z*getvZoom()/65536.0f )
		{
			node->color[1] = 0;node->color[2] = 0;
			if( node->childs )
			{
				crossAABB( ViewVect,node->childs  ,res );
				crossAABB( ViewVect,node->childs+1,res );
				crossAABB( ViewVect,node->childs+2,res );
				crossAABB( ViewVect,node->childs+3,res );
			}
			else
			{
				findIntersect( node,ViewVect,res );
			}
			return;
		}
	}

	temp = ( node->points[2].y - cam.y )/ViewVect.y;
	if( temp > 0 )
	{
		x = cam.x + temp*ViewVect.x;
		z = cam.z + temp*ViewVect.z;
		if( node->points[3].x < x && x < node->points[6].x && 
			node->points[3].z*getvZoom()/65536.0f < z && z < node->points[6].z*getvZoom()/65536.0f )
		{
			node->color[1] = 0;node->color[2] = 0;
			if( node->childs )
			{
				crossAABB( ViewVect,node->childs  ,res );
				crossAABB( ViewVect,node->childs+1,res );
				crossAABB( ViewVect,node->childs+2,res );
				crossAABB( ViewVect,node->childs+3,res );
			}
			else
			{
				findIntersect( node,ViewVect,res );
			}
			return;
		}
	}

	temp = ( node->points[0].x - cam.x )/ViewVect.x;
	if( temp > 0 )
	{
		y = cam.y + temp*ViewVect.y;
		z = cam.z + temp*ViewVect.z;
		if( node->points[0].y < y && y < node->points[7].y && 
			node->points[0].z*getvZoom()/65536.0f < z && z < node->points[7].z*getvZoom()/65536.0f )
		{
			node->color[1] = 0;node->color[2] = 0;
			if( node->childs )
			{
				crossAABB( ViewVect,node->childs  ,res );
				crossAABB( ViewVect,node->childs+1,res );
				crossAABB( ViewVect,node->childs+2,res );
				crossAABB( ViewVect,node->childs+3,res );
			}
			else
			{
				findIntersect( node,ViewVect,res );
			}
			return;
		}
	}

	temp = ( node->points[0].z*map->getvZoom()/65536.0f - cam.z )/ViewVect.z;
	if( temp > 0 )
	{
		x = cam.x + temp*ViewVect.x;
		y = cam.y + temp*ViewVect.y;
		if( node->points[0].x < x && x < node->points[2].x && 
			node->points[0].y < y && y < node->points[2].y )
		{
			node->color[1] = 0;node->color[2] = 0;
			if( node->childs )
			{
				crossAABB( ViewVect,node->childs  ,res );
				crossAABB( ViewVect,node->childs+1,res );
				crossAABB( ViewVect,node->childs+2,res );
				crossAABB( ViewVect,node->childs+3,res );
			}
			else
			{
				findIntersect( node,ViewVect,res );
			}
			return;
		}
	}

	temp = ( node->points[4].z*map->getvZoom()/65536.0f - cam.z )/ViewVect.z;
	if( temp > 0 )
	{
		x = cam.x + temp*ViewVect.x;
		y = cam.y + temp*ViewVect.y;
		if( node->points[4].x < x && x < node->points[6].x && 
			node->points[4].y < y && y < node->points[6].y )
		{
			node->color[1] = 0;node->color[2] = 0;
			if( node->childs )
			{
				crossAABB( ViewVect,node->childs  ,res );
				crossAABB( ViewVect,node->childs+1,res );
				crossAABB( ViewVect,node->childs+2,res );
				crossAABB( ViewVect,node->childs+3,res );
			}
			else
			{
				findIntersect( node,ViewVect,res );
			}
			return;
		}
	}

}


bool CmprLandscape::findIntersect( CQtrNode* node,vec3 vect,vec3* res)
{
	vec3 a,b,c;
	int i,j;

	for( i = (int)node->points[0].x;i < (int)node->points[6].x; i++ )
	for( j = (int)node->points[0].y;j < (int)node->points[6].y; j++ )
	{
#pragma warning ( disable : 4244 )
		a = vec3( i  , j  , HeightMap[i+iMapSizeX*j].usZ*getvZoom()/65536.0f );
		b = vec3( i+1, j+1, HeightMap[i+1+iMapSizeX*(j+1)].usZ*getvZoom()/65536.0f );
		c = vec3( i+1, j  , HeightMap[i+1+iMapSizeX*j].usZ*getvZoom()/65536.0f );
		findPointInTri( vect,a,b,c,res );
		a = vec3( i  , j  , HeightMap[i+iMapSizeX*j].usZ*getvZoom()/65536.0f );
		b = vec3( i  , j+1, HeightMap[i+iMapSizeX*(j+1)].usZ*getvZoom()/65536.0f );
		c = vec3( i+1, j+1, HeightMap[i+1+iMapSizeX*(j+1)].usZ*getvZoom()/65536.0f );
		findPointInTri( vect,a,b,c,res );
#pragma warning ( default : 4244 )
	}
	return true;
}


bool CmprLandscape::findPointInTri( vec3 View, vec3 a, vec3 b, vec3 c,vec3* res)
{
	vec3 N,ab,ac,I;
	float	D,NdpSP,t,fi;

	ab = b - a;
	ac = c - a;

	N.cross( ab,ac );
	D = -N.x*a.x - N.y*a.y - N.z*a.z;
	NdpSP = N.x*View.x+N.y*View.y+N.z*View.z;
	if(NdpSP == 0) return false;
		t = -(D + N.x*cam.x+N.y*cam.y+N.z*cam.z)/NdpSP;
		if(t < 0 || t > 1 || t > distance) return false;
		I = cam + View*t;
		fi = (I.y-a.y)*(b.x-a.x) - (I.x-a.x)*(b.y-a.y);
		if(fi>=0) return false;
		fi = (I.y-b.y)*(c.x-b.x) - (I.x-b.x)*(c.y-b.y);
		if(fi>=0) return false;
		fi = (I.y-c.y)*(a.x-c.x) - (I.x-c.x)*(a.y-c.y);
		if(fi>=0) return false;
		distance = t;
		*res = I;
	return true;
}

vec3 CmprLandscape::selectionRay(UINT nFlags, CPoint point)
{
	vec3 a,b;
	double e1,e2,e3;
	GLint   viewport[4];
	GLdouble projection[16];
	GLdouble modelview[16];
	glMatrixMode( GL_MODELVIEW );
	glPushMatrix();
	glLoadIdentity();
			glRotatef(cam.VA,1,0,0);
			glRotatef(cam.HA,0,0,1);
			glTranslated(-cam.x,-cam.y,-cam.z);
	
	glGetIntegerv(GL_VIEWPORT,viewport);
	glGetDoublev(GL_PROJECTION_MATRIX,projection);
	glGetDoublev(GL_MODELVIEW_MATRIX,modelview);
	point.y = viewport[3] - point.y - 1;
	gluUnProject( (double)point.x,(double)point.y, 1, modelview, projection, viewport,&e1,&e2,&e3);
	b = vec3( (float)e1, (float)e2, (float)e3 );
	gluUnProject( (double)point.x,(double)point.y,-1, modelview, projection, viewport,&e1,&e2,&e3);
	a = vec3( (float)e1, (float)e2, (float)e3 );
	glPopMatrix();

	a = b - a;
	vec3 x = map->findSelect( a );
	cam.pos = x;
	return a;


}

void CmprLandscape::displayWireFrame()
{
	glDisable( GL_TEXTURE_2D );
	glPolygonMode(GL_FRONT,GL_LINE);

	tree->displayWireFrame();

	glPolygonMode(GL_FRONT,GL_FILL);
	glEnable( GL_TEXTURE_2D );
}

void CmprLandscape::setTitle( unsigned int x, unsigned int y , unsigned int tID )
{
	wTiles[ x + iMapTitleSizeX*y ] = tID;
	tree->setNodeChanged( tree->root, x*2 , y*2 );
}

unsigned int CmprLandscape::getTitle(unsigned int x,unsigned int y, bool o)
{
	unsigned int Tit = wTiles[ x + iMapTitleSizeX*y ];
	if(o)for(Tit;Tit>=16384;Tit-=16384);
    return Tit;
}

void CmprLandscape::updateNormal( unsigned int x, unsigned int y )
{
	vec3 a,b,n,res;
	float t;
	a = vec3( 1.0f, 0.0f, getvZoom()/65536.0f*(float)(HeightMap[x+1+iMapSizeX*y].usZ - HeightMap[x+iMapSizeX*y].usZ) );
	b = vec3( 1.0f, 1.0f, getvZoom()/65536.0f*(float)(HeightMap[x+1+iMapSizeX*(y+1)].usZ - HeightMap[x+iMapSizeX*y].usZ) );

	res.cross( a,b );
	t = 1.0f/res.length();
	res *= t;

	a = vec3( 1.0f, 1.0f, getvZoom()/65536.0f*(float)(HeightMap[x+1+iMapSizeX*(y+1)].usZ - HeightMap[x+iMapSizeX*y].usZ) );
	b = vec3( 0.0f, 1.0f, getvZoom()/65536.0f*(float)(HeightMap[x+iMapSizeX*(y+1)].usZ - HeightMap[x+iMapSizeX*y].usZ) );
	n.cross( a,b );
	t = 1.0f/res.length();
	n *= t;
	res += n;

	a = vec3( 0.0f, 1.0f, getvZoom()/65536.0f*(float)(HeightMap[x+iMapSizeX*(y+1)].usZ - HeightMap[x+iMapSizeX*y].usZ) );
	b = vec3(-1.0f, 0.0f, getvZoom()/65536.0f*(float)(HeightMap[x-1+iMapSizeX*y].usZ - HeightMap[x+iMapSizeX*y].usZ) );
	n.cross( a,b );
	t = 1.0f/res.length();
	n *= t;
	res += n;

	a = vec3(-1.0f, 0.0f, getvZoom()/65536.0f*(float)(HeightMap[x-1+iMapSizeX*y].usZ - HeightMap[x+iMapSizeX*y].usZ) );
	b = vec3(-1.0f,-1.0f, getvZoom()/65536.0f*(float)(HeightMap[x-1+iMapSizeX*(y-1)].usZ - HeightMap[x+iMapSizeX*y].usZ) );
	n.cross( a,b );
	t = 1.0f/res.length();
	n *= t;
	res += n;

	a = vec3(-1.0f,-1.0f, getvZoom()/65536.0f*(float)(HeightMap[x-1+iMapSizeX*(y-1)].usZ - HeightMap[x+iMapSizeX*y].usZ) );
	b = vec3( 0.0f,-1.0f, getvZoom()/65536.0f*(float)(HeightMap[x+iMapSizeX*(y-1)].usZ - HeightMap[x+iMapSizeX*y].usZ) );
	n.cross( a,b );
	t = 1.0f/res.length();
	n *= t;
	res += n;

	a = vec3( 0.0f,-1.0f, getvZoom()/65536.0f*(float)(HeightMap[x+iMapSizeX*(y-1)].usZ - HeightMap[x+iMapSizeX*y].usZ) );
	b = vec3( 1.0f, 0.0f, getvZoom()/65536.0f*(float)(HeightMap[x+1+iMapSizeX*y].usZ - HeightMap[x+iMapSizeX*y].usZ) );
	n.cross( a,b );
	t = 1.0f/res.length();
	n *= t;
	res += n;

	res.x /= 6.0f;
	res.y /= 6.0f;
	res.z = 1;
	t = 1.0f/(float)sqrt( (res.x*res.x)+(res.y*res.y)+(res.z*res.z) );
	res *= t;

	HeightMap[x+iMapSizeX*y].uNormal = GetNormal( res.x,res.y,res.z );
}

void CmprLandscape::rotateTitle( unsigned int x, unsigned int y )
{
	int ind = x/2 + iMapTitleSizeX*y/2;
	int angle = (map->wTiles[ind] >> 14)+1;
	if( angle == 4 ) angle = 0;
	tree->setNodeChanged( tree->root, x , y );
	map->wTiles[ind] = (map->wTiles[ind] & 0x3FFF) | (angle << 14);
}

vec3 CmprLandscape::findSelectWater(vec3 ViewVect)
{
	distance = 1.0;
	vec3 res(-1000,-1000,-1000);
	crossAABBWater( ViewVect, tree->root,&res );
	return res;
}

void CmprLandscape::crossAABBWater(	vec3 ViewVect, CQtrNode* node,vec3* res )
{
	float temp,x,y,z;
	temp = ( node->points[0].y - cam.y )/ViewVect.y;
	if( temp > 0 )
	{
		x = cam.x + temp*ViewVect.x;
		z = cam.z + temp*ViewVect.z;
		if( node->points[0].x < x && x < node->points[5].x && 
			node->points[0].z*getvZoom()/65536.0f < z && z < node->points[5].z*getvZoom()/65536.0f )
		{
			node->color[1] = 0;node->color[2] = 0;
			if( node->childs )
			{
				crossAABBWater( ViewVect,node->childs  ,res );
				crossAABBWater( ViewVect,node->childs+1,res );
				crossAABBWater( ViewVect,node->childs+2,res );
				crossAABBWater( ViewVect,node->childs+3,res );
			}
			else
			{
				findIntersectWater( node,ViewVect,res );
			}
			return;
		}
	}

	temp = ( node->points[1].x - cam.x )/ViewVect.x;
	if( temp > 0 )
	{
		y = cam.y + temp*ViewVect.y;
		z = cam.z + temp*ViewVect.z;
		if( node->points[1].y < y && y < node->points[6].y && 
			node->points[1].z*getvZoom()/65536.0f < z && z < node->points[6].z*getvZoom()/65536.0f )
		{
			node->color[1] = 0;node->color[2] = 0;
			if( node->childs )
			{
				crossAABBWater( ViewVect,node->childs  ,res );
				crossAABBWater( ViewVect,node->childs+1,res );
				crossAABBWater( ViewVect,node->childs+2,res );
				crossAABBWater( ViewVect,node->childs+3,res );
			}
			else
			{
				findIntersectWater( node,ViewVect,res );
			}
			return;
		}
	}

	temp = ( node->points[2].y - cam.y )/ViewVect.y;
	if( temp > 0 )
	{
		x = cam.x + temp*ViewVect.x;
		z = cam.z + temp*ViewVect.z;
		if( node->points[3].x < x && x < node->points[6].x && 
			node->points[3].z*getvZoom()/65536.0f < z && z < node->points[6].z*getvZoom()/65536.0f )
		{
			node->color[1] = 0;node->color[2] = 0;
			if( node->childs )
			{
				crossAABBWater( ViewVect,node->childs  ,res );
				crossAABBWater( ViewVect,node->childs+1,res );
				crossAABBWater( ViewVect,node->childs+2,res );
				crossAABBWater( ViewVect,node->childs+3,res );
			}
			else
			{
				findIntersectWater( node,ViewVect,res );
			}
			return;
		}
	}

	temp = ( node->points[0].x - cam.x )/ViewVect.x;
	if( temp > 0 )
	{
		y = cam.y + temp*ViewVect.y;
		z = cam.z + temp*ViewVect.z;
		if( node->points[0].y < y && y < node->points[7].y && 
			node->points[0].z*getvZoom()/65536.0f < z && z < node->points[7].z*getvZoom()/65536.0f )
		{
			node->color[1] = 0;node->color[2] = 0;
			if( node->childs )
			{
				crossAABBWater( ViewVect,node->childs  ,res );
				crossAABBWater( ViewVect,node->childs+1,res );
				crossAABBWater( ViewVect,node->childs+2,res );
				crossAABBWater( ViewVect,node->childs+3,res );
			}
			else
			{
				findIntersectWater( node,ViewVect,res );
			}
			return;
		}
	}

	temp = ( node->points[0].z*map->getvZoom()/65536.0f - cam.z )/ViewVect.z;
	if( temp > 0 )
	{
		x = cam.x + temp*ViewVect.x;
		y = cam.y + temp*ViewVect.y;
		if( node->points[0].x < x && x < node->points[2].x && 
			node->points[0].y < y && y < node->points[2].y )
		{
			node->color[1] = 0;node->color[2] = 0;
			if( node->childs )
			{
				crossAABBWater( ViewVect,node->childs  ,res );
				crossAABBWater( ViewVect,node->childs+1,res );
				crossAABBWater( ViewVect,node->childs+2,res );
				crossAABBWater( ViewVect,node->childs+3,res );
			}
			else
			{
				findIntersectWater( node,ViewVect,res );
			}
			return;
		}
	}

	temp = ( node->points[4].z*map->getvZoom()/65536.0f - cam.z )/ViewVect.z;
	if( temp > 0 )
	{
		x = cam.x + temp*ViewVect.x;
		y = cam.y + temp*ViewVect.y;
		if( node->points[4].x < x && x < node->points[6].x && 
			node->points[4].y < y && y < node->points[6].y )
		{
			node->color[1] = 0;node->color[2] = 0;
			if( node->childs )
			{
				crossAABBWater( ViewVect,node->childs  ,res );
				crossAABBWater( ViewVect,node->childs+1,res );
				crossAABBWater( ViewVect,node->childs+2,res );
				crossAABBWater( ViewVect,node->childs+3,res );
			}
			else
			{
				findIntersectWater( node,ViewVect,res );
			}
			return;
		}
	}

}


bool CmprLandscape::findIntersectWater( CQtrNode* node,vec3 vect,vec3* res)
{
	vec3 a,b,c;
	int i,j;

	for( i = (int)node->points[0].x;i < (int)node->points[6].x; i++ )
	for( j = (int)node->points[0].y;j < (int)node->points[6].y; j++ )
	{
#pragma warning ( disable : 4244 )
		if(map->wObjectID[i/2+j/2*map->Header.dwXSectorsCount*16] != 0xffff)
		{
			a = vec3( i  , j  , WaterMap[i+iMapSizeX*j].usZ*getvZoom()/65536.0f );
			b = vec3( i+1, j+1, WaterMap[i+1+iMapSizeX*(j+1)].usZ*getvZoom()/65536.0f );
			c = vec3( i+1, j  , WaterMap[i+1+iMapSizeX*j].usZ*getvZoom()/65536.0f );
			findPointInTri( vect,a,b,c,res );
			a = vec3( i  , j  , WaterMap[i+iMapSizeX*j].usZ*getvZoom()/65536.0f );
			b =		vec3( i  , j+1, WaterMap[i+iMapSizeX*(j+1)].usZ*getvZoom()/65536.0f );
			c = vec3( i+1, j+1, WaterMap[i+1+iMapSizeX*(j+1)].usZ*getvZoom()/65536.0f );
			findPointInTri( vect,a,b,c,res );
		}
#pragma warning ( default : 4244 )
	}
	return true;
}

WORD CmprLandscape::getObjectID( unsigned int x,unsigned int y )
{
	return wObjectID[x+y*map->Header.dwXSectorsCount*16];
}


void CmprLandscape::invertObjectID( unsigned int x,unsigned int y )
{
	int ind = x+y*map->Header.dwXSectorsCount*16;
	wObjectID[ind] = (wObjectID[ind] == 0xffff)?0:0xffff;
	tree->setNodeChanged( tree->root, x*2 , y*2 );

}

void CmprLandscape::setObjectID( unsigned int x,unsigned int y,WORD id )
{
	wObjectID[x+y*map->Header.dwXSectorsCount*16] = id;
	tree->setNodeChanged( tree->root, x*2 , y*2 );
}

vec3 CmprLandscape::findNearest( vec3 from )
{
#pragma warning( disable:4244 )
	vec3 res,dist,pnt;
	float d;
	res = vec3( (int)from.x,(int)from.y,(float)map->getvZoom()/65535.0f*getHMapZ((int)from.x,(int)from.y) );
	dist = res - from;
	d = dist.length();

	pnt = vec3( (int)from.x+1,(int)from.y,(float)map->getvZoom()/65535.0f*getHMapZ((int)from.x+1,(int)from.y) );
	dist = pnt - from;
	if( dist.length() < d )
	{
		d = dist.length();
		res = pnt;
	}

	pnt = vec3( (int)from.x+1,(int)from.y+1,(float)map->getvZoom()/65535.0f*getHMapZ((int)from.x+1,(int)from.y+1) );
	dist = pnt - from;
	if( dist.length() < d )
	{
		d = dist.length();
		res = pnt;
	}

	pnt = vec3( (int)from.x,(int)from.y+1,(float)map->getvZoom()/65535.0f*getHMapZ((int)from.x,(int)from.y+1) );
	dist = pnt - from;
	if( dist.length() < d )
	{
		d = dist.length();
		res = pnt;
	}
return res;
#pragma warning( default:4244 )
}

vec3 CmprLandscape::scalePoint( unsigned int x,unsigned int y )
{
	return vec3( (float)x,(float)y,(float)getvZoom()/65535.0f*getHMapZ(x,y) );

}

float CmprLandscape::scaleZ( unsigned int x,unsigned int y )
{
	return (float)getvZoom()/65535.0f*getHMapZ(x,y);

}


float CmprLandscape::scaleZ( unsigned int z )
{
	return (float)getvZoom()/65535.0f*z;

}