// CmprLandscape.h: interface for the CmprLandscape class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "mathlib.h"	// Added by ClassView
#include "QuadTree.h"
#include "mprsection.h"
#include "mpHeader.h"
#include "Camera.h"
#include "ResManager.h"

#if !defined(AFX_CMPRLANDSCAPE_H__9FD1774C_6901_43D5_9FF6_F3201AB07BDF__INCLUDED_)
#define AFX_CMPRLANDSCAPE_H__9FD1774C_6901_43D5_9FF6_F3201AB07BDF__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

class MPRBASE_API CmprLandscape  
{
	friend class CQuadTree;
	friend class CCamera;
protected:
	WORD*			wTiles;
	WORD*			wAnimTiles;
	WORD*			wObjectID;
	mprSection*		section;
	unsigned int	iMapSizeX,iMapSizeY,iMapTitleSizeX,iMapTitleSizeY;
	GLuint*			textures;
	CMPHeader		Header;
/////////////////////////////minimap data//////////////////////////////////////
	SSectVert*	HeightMap;
	SSectVert*	WaterMap;

public:
	virtual void Save( CString csMmapName ,CString EIgamedir,CString SelfDir );
	virtual void display( bool,bool,bool );
	virtual void Load( /*prgProc proc*/);
	virtual float	getvZoom(){ return Header.fpMaxZ; };
	CmprLandscape();
	~CmprLandscape();
	CQuadTree*		tree;
	Camera cam;
/////////////////////////////////////////////////////////////////////////////
	float distance;
	virtual vec3	findSelect( vec3 ViewVect );
	virtual void	crossAABB(	vec3 ViewVect, CQtrNode* node,vec3* res );
	virtual bool	findIntersect( CQtrNode* node,vec3 vect,vec3* res);
	virtual bool	findPointInTri( vec3 View,vec3 a,vec3 b,vec3 c,vec3* res );
	virtual vec3	findNearest( vec3 );
/////////////////////////////////////////////////////////////////////////////
	virtual vec3	findSelectWater( vec3 ViewVect );
	virtual void	crossAABBWater(	vec3 ViewVect, CQtrNode* node,vec3* res );
	virtual bool	findIntersectWater( CQtrNode* node,vec3 vect,vec3* res);
/////////////////////////////////////////////////////////////////////////////
	virtual void updateNormal( unsigned int, unsigned int );
	virtual void displayWireFrame();
	virtual vec3 selectionRay( UINT nFlags, CPoint point );
	virtual unsigned short	getHMapZ(unsigned int,unsigned int);
	virtual unsigned short	getWMapZ(unsigned int,unsigned int);
	virtual void			setHMapZ(unsigned int,unsigned int,unsigned int);
	virtual void			setWMapZ(unsigned int,unsigned int,unsigned int);
	virtual WORD			getObjectID(unsigned int,unsigned int);
	virtual void			setObjectID(unsigned int,unsigned int,WORD);
	virtual void			invertObjectID(unsigned int,unsigned int);
	virtual void			setTitle(unsigned int X,unsigned int Y,unsigned int TitNum);
    virtual unsigned int	getTitle(unsigned int X,unsigned int Y,bool OptimizeZap);
	virtual void			rotateTitle( unsigned int,unsigned int );
   	virtual void			refresh();
	virtual vec3			scalePoint( unsigned int,unsigned int );
	virtual float			scaleZ( unsigned int,unsigned int );
	virtual float			scaleZ( unsigned int );
	virtual	GLuint			getTextures(int	offset)
	{ 
		if( offset >=0 && offset <= (int)Header.dwTextures*64 )
		return textures[offset]; 
		else return 0;
	};
	virtual	GLuint			getMapXDimension( ){ return iMapSizeX; };
	virtual	GLuint			getMapYDimension( ){ return iMapSizeY; };

	rgb*			MiniMapImage;
	unsigned int	MiniMapX,MiniMapY;
};

extern	CmprLandscape	*map;
#endif // !defined(AFX_CMPRLANDSCAPE_H__9FD1774C_6901_43D5_9FF6_F3201AB07BDF__INCLUDED_)
