// WaterGridDialog.cpp : implementation file
//

#include "stdafx.h"
#include "WaterGridDialog.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CWaterGridDialog dialog


CWaterGridDialog::CWaterGridDialog(CWnd* pParent /*=NULL*/)
	: CDialog(CWaterGridDialog::IDD, pParent)
{
	//{{AFX_DATA_INIT(CWaterGridDialog)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
}


void CWaterGridDialog::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CWaterGridDialog)
		// NOTE: the ClassWizard will add DDX and DDV calls here
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CWaterGridDialog, CDialog)
	//{{AFX_MSG_MAP(CWaterGridDialog)
	ON_WM_SIZE()
	ON_WM_PAINT()
	ON_WM_LBUTTONDOWN()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CWaterGridDialog message handlers

void CWaterGridDialog::OnSize(UINT nType, int cx, int cy) 
{
	CDialog::OnSize(nType, cx, cy);
	// TODO: Add your message handler code here
	
}

void CWaterGridDialog::OnPaint() 
{
	int i,j,x,y;
	CRect r;

	CPaintDC dc(this); // device context for painting
	
	// TODO: Add your message handler code here
	grid = (CStatic*)GetDlgItem( IDC_GRID_RECT );
	CPaintDC dx(grid);
	for( i=0;i<10;i++ )
	for( j=0;j<10;j++ )
	{
		x = centerCellX-5+i;
		y = centerCellY-5+j;
		if( titles[i][j] != 0xffff )
		{
			r.left   = i*STEP;
			r.right  = (i+1)*STEP;
			r.top    = (10-j)*STEP;
			r.bottom = (10-j-1)*STEP ;
			dx.FillRect( &r,&CBrush(RGB(0,0,255)) );
		}
		dx.MoveTo(i*STEP,0);
		dx.LineTo(i*STEP,GRID_EDGE);
		dx.MoveTo(0,i*STEP);
		dx.LineTo(GRID_EDGE,i*STEP);
	}
	for( i=0;i<=10;i++ )
	{
		dx.MoveTo(i*STEP,0);
		dx.LineTo(i*STEP,GRID_EDGE);
		dx.MoveTo(0,i*STEP);
		dx.LineTo(GRID_EDGE,i*STEP);
	}

	// Do not call CDialog::OnPaint() for painting messages
}

int CWaterGridDialog::DoModal( CmprLandscape * map,int x, int y ) 
{
	// TODO: Add your specialized code here and/or call the base class
	centerCellX = x/2;
	centerCellY = y/2;
	this->map = map;
	for(int i=0;i<10;i++)
		for(int j=0;j<10;j++)
		{
			titles[i][j] = map->getObjectID( centerCellX+i-5,centerCellY+j-5 );
		}
	return CDialog::DoModal();
}


void CWaterGridDialog::OnLButtonDown(UINT nFlags, CPoint point) 
{
	// TODO: Add your message handler code here and/or call default
	CDialog::OnLButtonDblClk(nFlags, point);
	MapWindowPoints( grid,&point,1);
	if(  point.x > 0 && point.y > 0 
	  && point.x < GRID_EDGE && point.y < GRID_EDGE)
	{
		int x,y;
		selectedCellX = (int)(point.x*10/GRID_EDGE);
		selectedCellY = 9-(int)(point.y*10/GRID_EDGE);

		x = selectedCellX;
		y = selectedCellY;
		titles[x][y] = (titles[x][y] == 0xffff)?0:0xffff;

			CRect r;
			r.left   = selectedCellX*STEP;
			r.right  = (selectedCellX+1)*STEP;
			r.top    = (10-selectedCellY)*STEP;
			r.bottom = (10-selectedCellY-1)*STEP ;
			grid->MapWindowPoints( this,&r );
		RedrawWindow( r );

	}
}

void CWaterGridDialog::OnOK() 
{
	// TODO: Add extra validation here
	for(int i=0;i<10;i++)
		for(int j=0;j<10;j++)
		{
			map->setObjectID( centerCellX+i-5,centerCellY+j-5,titles[i][j] );
		}
	CDialog::OnOK();
	map->refresh();
}
