#include "CTexPreset.h"
//-----------------------------------
void CTexPreset::LoadBuf(const CString Path)
{
	FILE *file;

	file = fopen(Path,"r");
    if(file)
	{	 
      if(BufLength>0)delete [] buf;

	  fseek(file,0,SEEK_END);
	  BufLength = ftell(file);
	  if(BufLength>4)
	  {
        buf = new byte[BufLength];
	    fseek(file,0,SEEK_SET);
	    fread(buf,BufLength,1,file);
	  }
	  else
	  {
        BufLength = 0;
	  }
      fclose(file);
	  //Init...
      
	  byte h1 = 28, h2 = 225, h3 = 0, h4 = 0;
	  
	  memcpy(&h3,buf,1);
      memcpy(&h4,buf+2,1);
	  if((h3!=h1 || h4!=h2) && (BufLength>0))
	  {
        BufLength = 0;
		delete [] buf;
	  }
	  if(BufLength>=5)
	  {
	    memcpy(&MatCount,buf+4,1);
		byte LN;
		int k=0;
		for(int i=0;i<MatCount;i++)
		{
			memcpy(&LN,buf+6+k,1);
            k+=LN+2;
		}
		if(BufLength>k+9)
		{
			memcpy(&ZapCount,buf+9+k,2);
		}
	  }
	}
}
void CTexPreset::SaveBuf(const CString Path)
{
	FILE *file;

	file = fopen(Path,"w");
    if(file)
	{	 
	  fseek(file,0,SEEK_SET);
	  fwrite(buf,BufLength,1,file);
      fclose(file);
	}
}
CString CTexPreset::GetCaption(const byte Num)
{
  if(BufLength<4)
	  return "Error#1 Void array";
  unsigned int Cursor = 5;
  
  byte N, L, Zero=0;
  CString Rez="";
  char *tmp;
  byte MatCnt = GetMatCount();
  bool ti = false;
  if(MatCnt>Num)
  {
      for(int i=0;i<=Num;i++)
	  {
        memcpy(&N,buf+Cursor,1);
	    Cursor++;
        memcpy(&L,buf+Cursor,1);
		Cursor++;
        //Rez.SetLength( (int)(L+1) );
		if(ti)delete [] tmp;
        tmp = new char[L+1];
		ti = true;
		memcpy(tmp,buf+Cursor,L);
		Cursor+=L;
		memcpy(tmp+L,&Zero,1);
	  }
      Rez = CString(tmp,L+1);
	  delete [] tmp;
  }
  return Rez;
}

int CTexPreset::GetCode(const byte Num)
{
  if(BufLength<4)
	  return 0;
  unsigned int Cursor = 5;
  
  byte N, L, Zero=0;
  if(GetMatCount()>Num)
      for(int i=0;i<=Num;i++)
	  {
        memcpy(&N,buf+Cursor,1);
	    Cursor++;
        memcpy(&L,buf+Cursor,1);
		Cursor++;
        Cursor+=L;
	  }
  return N;
}

CTile CTexPreset::GetZap(const int Num)
{
    CTile Rez=CTile();
	if(Num<GetZapCount())
	{
	  if(BufLength>=5)
	  {
		byte LN;
		int k=0;
		for(int i=0;i<MatCount;i++)
		{
			memcpy(&LN,buf+6+k,1);
            k+=LN+2;
		}
		if(BufLength>k+9)
		{
			k+=9+2;
			for(int i=0;i<=Num;i++)
			{
				byte a,b,c,d;
				memcpy(&a,buf+k,1);
				k++;
				memcpy(&b,buf+k,1);
				k++;
				memcpy(&c,buf+k,1);
				k++;
				memcpy(&d,buf+k,1);
				k++;
				Rez = CTile(a,b,c,d);
			}
		}
	  }
	}
	return Rez;
}
void CTexPreset::SetZap(const int Num, const CTile *Zap)
{
	CTile Til;
	int Len = 0;
	byte LN=0;
	int k=0;
	// 
	for(int i=0;i<MatCount;i++)
	{
		memcpy(&LN,buf+6+k,1);
        k+=LN+2;
	}
    // 
	k+=9+2+4*(Num-1);
    memcpy(buf+k+0,&(Zap->A),1);
	memcpy(buf+k+1,&(Zap->B),1);
	memcpy(buf+k+2,&(Zap->C),1);
	memcpy(buf+k+3,&(Zap->D),1);
}


int* CTexPreset::FindZap(const CTile *Mask)
{
	//2Sagres:        GetZap? 
	  //    .    ,   Num.
	int *Rez=new int[1];
	CTile Til;
	int Len = 0;
	memcpy(Rez,&Len,4);
	
	byte LN=0;
	int k=0;
	// 
	for(int i=0;i<MatCount;i++)
	{
		memcpy(&LN,buf+6+k,1);
        k+=LN+2;
	}
    //   
	k+=9+2;
	for(int i=0;i<ZapCount;i++)
	{
		byte a,b,c,d;
		memcpy(&a,buf+k,1);
		k++;
		memcpy(&b,buf+k,1);
		k++;
		memcpy(&c,buf+k,1);
		k++;
		memcpy(&d,buf+k,1);
		k++;
		Til = CTile(a,b,c,d);
		if(Til == *Mask)
			Rez = AddElement(Rez,i);
		else
		{
			Til.Rotate();
			if(Til == *Mask)
			  Rez = AddElement(Rez,i);
			else
			{
				Til.Rotate();
				if(Til == *Mask)
				  Rez = AddElement(Rez,i);
				else
				{
				  Til.Rotate();
				  if(Til == *Mask)
				    Rez = AddElement(Rez,i);
				}
			}
		}
	}
	
	return Rez;
}
int* CTexPreset::AddElement(int *Buffer, int Element)
{
	int Len;
	memcpy(&Len,Buffer,4);
	int* tmp=new int[Len+2];
	memcpy(tmp,Buffer,Len*4+4);
	memcpy(tmp+Len+1,&Element,4);
	Len++;
	memcpy(tmp,&Len,4);
	delete [] Buffer;
	Buffer = new int[Len+1];
	memcpy(Buffer,tmp,Len*4+4);
	delete [] tmp;
	return Buffer;
}
int CTexPreset::GetRandomZap(int *Block)
{
	int r=0;

	int Len=0, Rez=-1;
	memcpy(&Len,Block,4);
	if(Len>0)
	{
	  //   
	  r = Rnd(Len,(unsigned int)time(NULL));
      memcpy(&Rez,Block+1+r,4);
	}
	return Rez;
}
CTile CTexPreset::RotateTile(CTile Zap, byte Angle)
{
	CTile Rez = Zap;
    for(int i=0;i<Angle;i++)
	{
		Rez.Rotate();
	}
    return Rez;
}

void CTexPreset::RotateTile(byte *Tile)
{
	//ABCD->CADB
	byte *r = new byte[4];
	memcpy(r+0,Tile+2,1);
	memcpy(r+1,Tile+0,1);
	memcpy(r+2,Tile+3,1);
	memcpy(r+3,Tile+1,1);
	//Apply rotation
	memcpy(Tile,r,4);

	delete [] r;
}

int CTexPreset::GetRotNumber(int TileNum)
{
	//    ?
	int i;
	for(i=0;TileNum>=16384*(i+1);i++);
	return i;
}

int CTexPreset::GetRotNumber(byte *Tile, byte *Mask)
{
	//    ,     
	int A1, A2, i;
	memcpy(&A1,Tile,4);
	memcpy(&A2,Mask,4);
	if(A1==A2)
	{
		i=0;
	}
	else
	{
		RotateTile(Tile);
		memcpy(&A1,Tile,4);
		if(A1==A2)
		{
			i=1;
		}
		else
		{
			RotateTile(Tile);
            memcpy(&A1,Tile,4);
		    if(A1==A2)
		    {
    			i=2;
		    }
			else
			{
				RotateTile(Tile);
				memcpy(&A1,Tile,4);
				if(A1==A2)
				{
	    			i=3;
				}	
				else
				{
					i = -1;
				}
			}
		}
	}
	return i;
}

byte* CTexPreset::GetZapEx(int Num)
{
    byte* Rez=new byte[4];
	int Rot = GetRotNumber(Num);
	Num-=Rot*16384;
	if(Num<GetZapCount())
	{
	  if(BufLength>=5)
	  {
		byte LN;
		int k=0;
		for(int i=0;i<MatCount;i++)
		{
			memcpy(&LN,buf+6+k,1);
            k+=LN+2;
		}
		if(BufLength>k+9)
		{
			k+=9+2;
			for(int i=0;i<=Num;i++)
			{
				//byte a,b,c,d;
				memcpy(Rez+0,buf+k,1);
				k++;
				memcpy(Rez+1,buf+k,1);
				k++;
				memcpy(Rez+2,buf+k,1);
				k++;
				memcpy(Rez+3,buf+k,1);
				k++;
				
			}
		}
	  }
	}
	for(int i=0;i<Rot;i++)
	{
		byte *t = new byte[4];
		memcpy(t,Rez,4);
		RotateTile(t);
		memcpy(Rez,t,4);
		delete [] t;
	}
	return Rez;
}

int CTexPreset::Rnd(int Seed, int RS)
{
	unsigned int k = (unsigned)time( NULL ) + rand();
	srand( k );
	if(RS != 1)
		srand( (unsigned)(RS-k));
	int l = rand();
	int Rez = (Seed!=0)?l%Seed:l;
	return Rez;
}

bool CTexPreset::MatExists(byte Code)
{
	bool b=false;
	for(int i=0;(i<GetMatCount())&&(!b);i++)
	{
		b = GetCode(i)==Code;
	}
	return b;
}