/////////////////////////////////
#include "stdafx.h"
#include <stdlib.h>
#include <resource.h>
/////////////////////////////////
/////////////////
class CTile
{
private:
public:
	byte A, B, C, D;
	int Number;
	bool operator == (CTile X)
	{
		return ((X.A == A) && (X.B == B) && (X.C == C) && (X.D == D));
	}

	bool IsSolidTile()
	{
		bool b = ((A==B)&&(B==C)&&(C==D)&&(A==D));//   
		return b;
	}
	CTile& operator =(const CTile X)
	{
		A = X.A;
		B = X.B;
		C = X.C;
		D = X.D;
		return *this;
	}

	CTile(byte a=0, byte b=0, byte c=0, byte d=0)
	{
		A = a;
		B = b;
		C = c;
		D = d;
		Number = 0;
	}

	
	CTile(byte *Tile)
	{
		memcpy(&A,Tile+0,1);
		memcpy(&B,Tile+1,1);
		memcpy(&C,Tile+2,1);
		memcpy(&D,Tile+3,1);
		Number = 0;
	}

	CTile(int *Til)
	{
		byte *Tile = new byte[4];
		memcpy(Tile,Til,4);
		*this = CTile(Tile);
		delete [] Tile;
	}

	CTile(const CTile *a)
	{
		A = a->A;
		B = a->A;
		C = a->C;
		D = a->D;
		Number = a->Number;
	}

	CTile& Rotate()
	{
		CTile Tmp = *this;
		A = Tmp.C;
		B = Tmp.A;
		C = Tmp.D;
		D = Tmp.B;
		return *this;
	}

	CString ToString()
	{
		CString Rez="";
		Rez.Format("%d,%d\r\n%d,%d",A,B,C,D);
		return Rez;
	}
};



/////////////////
class CTexPreset
{
private:
	byte *buf;
	WORD ZapCount;
	byte MatCount;
	int BufLength;

public:
	virtual void LoadBuf(const CString Path);
	virtual void SaveBuf(const CString Path);
    CString GetCaption(const byte Num);
	int GetCode(const byte Num);
	virtual CTile GetZap(const int Num);
	byte *GetZapEx(int Num);
	virtual void SetZap(const int Num, const CTile *Zap);
	virtual int* FindZap(const CTile *Mask);
	virtual int* FindZap(const CTile Mask)
	{
		CTile T = Mask;
		return FindZap(&T);
	}
    virtual int GetRandomZap(int *Block);
	virtual CTile RotateTile(CTile Zap, byte Angle);

	int Rnd(int Seed, int RS = 1);

	void RotateTile(byte *Tile);
	int GetRotNumber(int TileNum);
	int GetRotNumber(byte *Tile, byte *Mask);
    

	//System...
	virtual int *AddElement(int *Buffer, int Element);

	//------------------------
	virtual byte *GetFileBuf()
	{
		
		return buf;
	}
    virtual byte GetMatCount()
	{
		return MatCount;
	}

	virtual bool MatExists(byte Code);
    //-------------------------
	virtual WORD GetZapCount()
	{
		return ZapCount;
	}

	virtual int GetBufLength()
	{
		return BufLength;
	}
	//-------------------------
	CTexPreset()
	{
		BufLength = 0;
	}
    //-------------------------
	~CTexPreset()
	{
		if(BufLength>0)
		  delete [] buf;
	}
	//-------------------------
};



extern	CTexPreset	*tOpt;