// CPlugin.cpp : implementation file
//

#include "stdafx.h"
#include "resource.h"
#include "Ctexman.h"
#include <EIplugin\cplugin_base.h>
#include <time.h>

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif
#include "resource.h"
#include ".\ctexman.h"
CTex	plugin;
/////////////////////////////////////////////////////////////////////////////
// CPlugin dialog

CTex::CTex()
	: CPlugin( )
{
	//{{AFX_DATA_INIT(CTex)
	//}}AFX_DATA_INIT
}


void CTex::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CTex)
	DDX_Control(pDX, IDC_BRUSH, m_brush);
	//}}AFX_DATA_MAP
	DDX_Control(pDX, IDC_MAT_LIST, MList);
}

void CTex::Create( CWnd* pParentWnd )
{
	CDialog::Create( CTex::IDD, pParentWnd );
	tip ="Textures";
	icon = AfxGetApp()->LoadIcon(IDI_ICON1);
	CurrentMaterial=0;
}

BEGIN_MESSAGE_MAP(CTex, CDialog)
	//{{AFX_MSG_MAP(CTex)
	ON_WM_PAINT()
	ON_BN_CLICKED(IDC_SINGLE_TITLE, OnSingleTitle)
	//}}AFX_MSG_MAP
	ON_BN_CLICKED(IDC_LOAD_CFG, OnBnClickedLoadCfg)
	ON_BN_CLICKED(IDC_TESTBUTTON, OnBnClickedTestbutton)
	ON_LBN_SELCHANGE(IDC_MAT_LIST, OnLbnSelchangeMatList)
	ON_BN_CLICKED(IDC_EXTENDED, OnBnClickedExtended)
	ON_BN_CLICKED(IDC_RND_MAP, OnBnClickedRndMap)
	ON_WM_TIMER()
	ON_STN_CLICKED(IDC_SINGLE_TITLE, OnStnClickedSingleTitle)
END_MESSAGE_MAP()


void CTex::onMouseMove    ( UINT nFlags, CPoint point )
{
/////////////
	//    Normal
//////////////
	vec3 vs,ptr;
	vs =  map->selectionRay( nFlags, point );
	ptr = map->findSelect( vs );
	x = (unsigned int)ptr.x;
	y = (unsigned int)ptr.y;
	z = (unsigned int)ptr.z;

	x = x/2*2;
	y = y/2*2;

	endPos.x = x;
	endPos.y = y;

	RefreshInfo(x/2,y/2);
	if( m_brush.GetState( ) )
	{
		int x1,y1,x2,y2;

		x1 = min( startPos.x,endPos.x );
		x2 = max( startPos.x,endPos.x );
		y1 = min( startPos.y,endPos.y );
		y2 = max( startPos.y,endPos.y );

	}
	else
	if( nFlags & MK_LBUTTON  )
	{
		if(!IsDlgButtonChecked(IDC_PIPETKA))
		{
			if(!IsDlgButtonChecked(IDC_EXTENDED))
			{
				map->setTitle( x/2,y/2,m.getCurrentTitle() );
			}
			else
			{
				TextureExtended(x/2,y/2,CurrentMaterial);
			}
		}
		else
		{
			int i=map->getTitle(x/2,y/2,true);
			m.setCurrentTitle(i);
			RedrawWindow( CRect(0,0,3000,3000) );
			OnPaint();
		}
	}
	map->refresh();

//////////////
	//    Random part
//////////////
    GR = (int)tOpt.Rnd(1000,x+y-z);
};
void CTex::onRButtonDown  ( UINT nFlags, CPoint point )
{
	vec3 vs,ptr;
	vs =  map->selectionRay( nFlags, point );
	ptr = map->findSelect( vs );
	x = (unsigned int)ptr.x;
	y = (unsigned int)ptr.y;	
	z = (unsigned int)ptr.z;

	x = x/2*2;
	y = y/2*2;
	startPos.x = x;
	startPos.y = y;
    if( !m_brush.GetState( ) )
		if(!GetAsyncKeyState( VK_CONTROL ))
		{
			vec3 vs,ptr;
			vs =  map->selectionRay( nFlags, point );
			ptr = map->findSelect( vs );
			x = (unsigned int)ptr.x;
			y = (unsigned int)ptr.y;
			z = (unsigned int)ptr.z;

			x = x/2*2;
			y = y/2*2;
			startPos.x = x;
			startPos.y = y;
			
			map->rotateTitle( x,y );	

			map->refresh();
		}
		else
		{
			vec3 vs,ptr;
			vs =  map->selectionRay( nFlags, point );
			ptr = map->findSelect( vs );
			x = (unsigned int)ptr.x;
			y = (unsigned int)ptr.y;
			z = (unsigned int)ptr.z;

			x = x/2*2;
			y = y/2*2;
			startPos.x = x;
			startPos.y = y;
			CString msg = "";
			msg.Format("%d",map->getTitle(x/2,y/2,true));
			MessageBox( msg, " ...");
			map->refresh();
		}
	RefreshInfo(x/2,y/2);
};

void CTex::onLButtonDown  ( UINT nFlags, CPoint point )
{
	vec3 vs,ptr;
	vs =  map->selectionRay( nFlags, point );
	ptr = map->findSelect( vs );
	x = (unsigned int)ptr.x;
	y = (unsigned int)ptr.y;	
	z = (unsigned int)ptr.z;

	x = x/2*2;
	y = y/2*2;
	startPos.x = x;
	startPos.y = y;
	if(!IsDlgButtonChecked(IDC_PIPETKA))
	{
		if(!IsDlgButtonChecked(IDC_EXTENDED))
		{
			map->setTitle( x/2,y/2,m.getCurrentTitle() );
		}
		else
		{
			TextureExtended(x/2,y/2,CurrentMaterial);
		}
	}
	else
	{
		int i=map->getTitle(x/2,y/2,true);
		m.setCurrentTitle(i);
		RedrawWindow( CRect(0,0,3000,3000) );
		OnPaint();
	}
	RefreshInfo(x/2,y/2);
	map->refresh();
};
void CTex::onLButtonUp  ( UINT nFlags, CPoint point )
{
	if(!IsDlgButtonChecked(IDC_PIPETKA))
	{
		if( m_brush.GetState( ) )
		{
			int i,j,x1,y1,x2,y2;

			x1 = min( startPos.x,endPos.x );
			x2 = max( startPos.x,endPos.x );
			y1 = min( startPos.y,endPos.y );
			y2 = max( startPos.y,endPos.y );
			for( i = x1;i<x2;i++ )
			for( j = y1;j<y2;j++ )
			{
				if(!IsDlgButtonChecked(IDC_EXTENDED))
			    {
					map->setTitle( i/2,j/2,m.getCurrentTitle() );
			    }
				else
				{
					TextureExtended(i/2,j/2,CurrentMaterial, false);
				}
			}
			//Extended borders
			if(IsDlgButtonChecked(IDC_EXTENDED))
			{
				for(i = x1;i<x2;i++)
					TextureExtended(i/2,y1/2,CurrentMaterial);//  
				for(i = x1;i<x2;i++)
					TextureExtended(i/2,(y2-1)/2,CurrentMaterial);//  
				for(j = y1;j<y2;j++)
					TextureExtended(x1/2,j/2,CurrentMaterial);//  
				for(j = y1;j<y2;j++)
					TextureExtended((x2-1)/2,j/2,CurrentMaterial);//  
			}
		}
		else
		{
			if(!IsDlgButtonChecked(IDC_EXTENDED))
			{
			  map->setTitle( x/2,y/2,m.getCurrentTitle() );
			}
		}
	}
	map->refresh();	
};

void CTex::onLButtonDblClk( UINT nFlags, CPoint point )
{
};
void CTex::onRButtonDblClk( UINT nFlags, CPoint point )
{

};

/////////////////////////////////////////////////////////////////////////////
// CTex message handlers
CPlugin*	getPlugin( )
{
	return (CTex*)(&plugin);
}

void CTex::onPluginSelect()
{
	if(!GetDlgItem(IDC_EXTENDED)->IsWindowEnabled())
	{
		CString t="";
		t.Format("%s\\%s.opt",ProgaOpts->ProgDir,ProgaOpts->RealMapName);
		tOpt.LoadBuf(t);
		if(tOpt.GetBufLength()>0)
		{
			FillMatList();
			GetDlgItem(IDC_EXTENDED)->EnableWindow(TRUE);
		}
	}
}

void CTex::onPluginUnSelect()
{
}

void CTex::display()
{
	glDisable( GL_TEXTURE_2D );
	glDisable( GL_DEPTH_TEST );
	glPolygonMode( GL_FRONT, GL_LINE );
	if( m_brush.GetState( ) && (GetAsyncKeyState( VK_LBUTTON )  || GetAsyncKeyState( VK_RBUTTON ) ))
	{
		int i,j,x1,y1,x2,y2;

		x1 = min( startPos.x,endPos.x );
		x2 = max( startPos.x,endPos.x );
		y1 = min( startPos.y,endPos.y );
		y2 = max( startPos.y,endPos.y );

		glColor3f(1,0,0);

		glBegin( GL_LINE_STRIP );
		j = y1;
		for( i=x1;i<x2;i++ )
			glVertex3f((float)i,(float)j,map->getHMapZ(i,j)*map->getvZoom()/65536.0f);	
		i = x2;
		for( j=y1;j<y2;j++ )
			glVertex3f((float)i,(float)j,map->getHMapZ(i,j)*map->getvZoom()/65536.0f);
		j = y2;
		for( i=x2;i>x1;i-- )
			glVertex3f((float)i,(float)j,map->getHMapZ(i,j)*map->getvZoom()/65536.0f);
		i = x1;
		for( j=y2;j>y1;j-- )
			glVertex3f((float)i,(float)j,map->getHMapZ(i,j)*map->getvZoom()/65536.0f);
		glEnd();
		glColor3f(1,1,1);
	}
	else
	{
			glBegin( GL_LINE_STRIP );
				glVertex3f( (float)x  ,(float)y  ,map->getHMapZ( x  ,y   )*map->getvZoom()/65536.0f );
				glVertex3f( (float)x+1,(float)y  ,map->getHMapZ( x+1,y   )*map->getvZoom()/65536.0f );
				glVertex3f( (float)x+2,(float)y  ,map->getHMapZ( x+2,y   )*map->getvZoom()/65536.0f );
				glVertex3f( (float)x+2,(float)y+1,map->getHMapZ( x+2,y+1 )*map->getvZoom()/65536.0f );
				glVertex3f( (float)x+2,(float)y+2,map->getHMapZ( x+2,y+2 )*map->getvZoom()/65536.0f );
				glVertex3f( (float)x+1,(float)y+2,map->getHMapZ( x+1,y+2 )*map->getvZoom()/65536.0f );
				glVertex3f( (float)x  ,(float)y+2,map->getHMapZ( x  ,y+2 )*map->getvZoom()/65536.0f );
				glVertex3f( (float)x  ,(float)y+1,map->getHMapZ( x  ,y+1 )*map->getvZoom()/65536.0f );
			glEnd();
	}
	glPolygonMode( GL_FRONT, GL_FILL );
	glEnable( GL_TEXTURE_2D );
	glEnable( GL_DEPTH_TEST );
}

void CTex::onMouseWheel(UINT nFlags, short zDelta, CPoint pt)
{
	map->cam.z += 0.05f*zDelta;
}

void CTex::OnPaint() 
{
	CPaintDC(this); // device context for painting
	CPaintDC dx( GetDlgItem( IDC_SINGLE_TITLE ) );	
	static int drawTex = -1;
	for(int i=0;i<10000;i++);
	if( drawTex != (int)m.getCurrentTitle() )
	{
		rgb a[64*64];
		drawTex = m.getCurrentTitle();
		glBindTexture( GL_TEXTURE_2D, map->getTextures( drawTex ) );
		glGetTexImage( GL_TEXTURE_2D , 0, GL_RGB, GL_UNSIGNED_BYTE, a );
		for(int i=0;i<64;i++)
		for(int j=0;j<64;j++)
		{
			dcMem.SetPixel(i,64-j,RGB(a[i+64*j].r,a[i+64*j].g,a[i+64*j].b));
		}
	}
	dx.BitBlt(0,0,64,64,&dcMem,0,0,SRCCOPY );
	// TODO: Add your message handler code here
	
	// Do not call CDialog::OnPaint() for painting messages
}

BOOL CTex::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	CWnd* wnd = GetDlgItem( IDC_SINGLE_TITLE );
	wnd->SetWindowPos( this, 5,5,64,64, SWP_NOZORDER | SWP_SHOWWINDOW );

	hdcScreen = wnd->GetDC( );
	hbmScreen.CreateCompatibleBitmap( hdcScreen,64,64 );
	dcMem.CreateCompatibleDC( hdcScreen );
	dcMem.SelectObject( hbmScreen );
	// TODO: Add extra initialization here
	SetTimer(0,10,NULL);
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void CTex::OnSingleTitle() 
{
	// TODO: Add your control notification handler code here
	if( m.execute() )
	{
		RedrawWindow( CRect(0,0,3000,3000) );
	}
}

void CTex::onRButtonUp (UINT nFlags, CPoint point)
{
	if( m_brush.GetState( ) )
	{
		int x1,y1,x2,y2;

		x1 = min( startPos.x,endPos.x );
		x2 = max( startPos.x,endPos.x );
		y1 = min( startPos.y,endPos.y );
		y2 = max( startPos.y,endPos.y );

		if(!GetAsyncKeyState( VK_CONTROL ))
		{
		  RandomizeRect(x1/2,y1/2,x2/2,y2/2);
		}
		else
		{
		  RandomRotRect(x1/2,y1/2,x2/2,y2/2);
		}
		map->refresh();
	}
}

HICON CTex::getIcon()
{
	return NULL;
}
void CTex::OnBnClickedLoadCfg()
{
OPENFILENAME ofstruct;
	char *Filters;
	CString FileName;
	//bool DialogResult;

	// ...
	Filters = new char[23];
	Filters = "  \0*.opt\0\0";
	//    ...
	FileName.GetBufferSetLength(256);
	// ...
	ZeroMemory(&ofstruct,sizeof (OPENFILENAME)); 

	ofstruct.lStructSize = sizeof (OPENFILENAME);
	ofstruct.hwndOwner = ProgaOpts->PAppObject->m_pMainWnd->m_hWnd;
	ofstruct.lpstrFilter = Filters;
	ofstruct.nFilterIndex = 1;  // 1- ;
	ofstruct.lpstrFile = FileName.GetBuffer(0);
	ofstruct.nMaxFile = 256;
	ofstruct.lpstrInitialDir = ProgaOpts->ProgDir;
	ofstruct.lpstrTitle = "     ? ? ? ?(? _)";
	ofstruct.lpstrDefExt = "opt";
	ofstruct.Flags = OFN_FILEMUSTEXIST;
	
    CString test;
	if (GetOpenFileName(&ofstruct))
	{
      tOpt.LoadBuf((CString)ofstruct.lpstrFile);
	  test.Format(" %d   %d ",tOpt.GetMatCount(),tOpt.GetZapCount());
	  GetDlgItem(IDC_EXTENDED)->EnableWindow(TRUE);
	  SetDlgItemText(IDC_CONFIG_INFO,test);

	  FillMatList();
	}
}

void CTex::OnBnClickedTestbutton()
{
	CString test="";
	MessageBox("    \"C:\\system32\\kernel32.dll\" -  ,   ");
	RandomRotRect(0,0,map->getMapXDimension(),map->getMapYDimension());
	map->refresh();
}

void CTex::FillMatList()
{
  ////////////////////
  //    Clear list
  MList.ResetContent();
  /////////////////////
  // Add materials...
  for(int i=0;i<tOpt.GetMatCount();i++)
  {
	  // ,    .    ;)
	  CString cap = tOpt.GetCaption(i);
	  MList.AddString(cap);
  }
  /////////////////////
  //    Refreshing...
}

////////////////////////////////////////////////////////////////
//               !   Texture extended   !
////////////////////////////////////////////////////////////////
void CTex::TextureExtended(unsigned int x, unsigned int y, byte N, bool IsExt)
{
	//!
	// x, y -  ,     
	// N -  ,   ! 

	//%)

	int MLX = (map->getMapXDimension()-1)/2;
	int MLY = (map->getMapXDimension()-1)/2;

	if(IsExt)
	{
		int *Buffer = new int[25];
		// 
		for(int i=0;i<25;i++)
			Buffer[i]=0;
	//   
		
		for(int k=0;k<5;k++)
			for(int i=0;i<5;i++)
			{
				bool mz=(x+i>=2)&&(y+2>=k); //More Zero
				bool ld=(x-2+i<MLX)&&(y+2-k<MLY);//Less dimensions
				if(mz&&ld)
				{
					int Num1 = map->getTitle(x-2+i, y+2-k,true);
					byte *r = tOpt.GetZapEx(Num1);
					int Num2 = tOpt.GetRotNumber(map->getTitle(x-2+i, y+2-k,false));

					for(int j=0;j<Num2;j++)
						tOpt.RotateTile(r);
					
					memcpy(Buffer+k*5+i,r,4);
					delete [] r;
				}
			}
	//...
	//      
		byte *tmp = new byte[4];
		byte t=0;
		memcpy(tmp+0,&N,1);
		memcpy(tmp+1,&N,1);
		memcpy(tmp+2,&N,1);
		memcpy(tmp+3,&N,1);
		memcpy(Buffer+12,tmp,4);
		delete [] tmp;
	//,  ,  8 -, ...
		byte *A = new byte[4];
		byte *B = new byte[4];
		byte *C = new byte[4];
		byte *D = new byte[4];
		byte *E = new byte[4];
		byte *F = new byte[4];
		byte *G = new byte[4];
		byte *H = new byte[4];
	//...    
		// ,    
		memcpy(A+3,&N,1);
		memcpy(B+2,&N,1);
		memcpy(B+3,&N,1);
		memcpy(C+2,&N,1);
		memcpy(D+1,&N,1);
		memcpy(D+3,&N,1);
		memcpy(E+0,&N,1);
		memcpy(E+2,&N,1);
		memcpy(F+1,&N,1);
		memcpy(G+0,&N,1);
		memcpy(G+1,&N,1);
		memcpy(H+0,&N,1);
	/////////////////////////////////////////////////////////////
	//      -  ...
	/////////////////////////////////////////////////////////////
		tmp = new byte[4];
		//---- A[0]
		memcpy(tmp,Buffer+0,4);
		if(tmp[3]!=0){memcpy(A,tmp+3,1);}
		else{memcpy(tmp,Buffer+1,4);
			if(tmp[2]!=0){memcpy(A,tmp+2,1);}
			else{memcpy(tmp,Buffer+5,4);
    			if(tmp[1]!=0){memcpy(A,tmp+1,1);}
				else{memcpy(A,&N,1);}}}
		//---- A[1]
		memcpy(tmp,Buffer+1,4);
		if(tmp[3]!=0){memcpy(A+1,tmp+3,1);}
		else{memcpy(A+1,&N,1);}
		//---- A[2]
		memcpy(tmp,Buffer+5,4);
		if(tmp[3]!=0){memcpy(A+2,tmp+3,1);}
		else{memcpy(A+2,&N,1);}
		//---- B[0]
		memcpy(tmp,Buffer+1,4);
		if(tmp[3]!=0){memcpy(B,tmp+3,1);}
		else{memcpy(tmp,Buffer+2,4);
		if(tmp[2]!=0){memcpy(B,tmp+2,1);}
		else{memcpy(B,&N,1);}}
		//---- B[1]
		memcpy(tmp,Buffer+2,4);
		if(tmp[3]!=0){memcpy(B+1,tmp+3,1);}
		else{memcpy(B+1,&N,1);}
		//---- C[0]
		memcpy(tmp,Buffer+2,4);
		if(tmp[3]!=0){memcpy(C,tmp+3,1);}
		else{memcpy(tmp,Buffer+3,4);
		if(tmp[2]!=0){memcpy(C,tmp+2,1);}
		else{memcpy(C,&N,1);}}
		//---- C[1]
		memcpy(tmp,Buffer+3,4);
		if(tmp[3]!=0){memcpy(C+1,tmp+3,1);}
		else{memcpy(tmp,Buffer+4,4);
		if(tmp[2]!=0){memcpy(C+1,tmp+2,1);}
		else{memcpy(tmp,Buffer+9,4);
			if(tmp[0]!=0){memcpy(C+1,tmp,1);}
			else{memcpy(C+1,&N,1);}}}
		//---- C[3]
		memcpy(tmp,Buffer+9,4);
		if(tmp[2]!=0){memcpy(C+3,tmp+2,1);}
		else{memcpy(tmp,Buffer+14,4);
		if(tmp[0]!=0){memcpy(C+3,tmp,1);}
		else{memcpy(C+3,&N,1);}}
		//---- D[0]
		memcpy(tmp,Buffer+5,4);
		if(tmp[3]!=0){memcpy(D,tmp+3,1);}
		else{memcpy(tmp,Buffer+10,4);
		if(tmp[1]!=0){memcpy(D,tmp+1,1);}
		else{memcpy(D,&N,1);}}
		//---- D[2]
		memcpy(tmp,Buffer+10,4);
		if(tmp[3]!=0){memcpy(D+2,tmp+3,1);}
		else{memcpy(tmp,Buffer+15,4);
		if(tmp[1]!=0){memcpy(D+2,tmp+1,1);}
		else{memcpy(D+2,&N,1);}}
		//---- E[1]
		memcpy(tmp,Buffer+9,4);
		if(tmp[2]!=0){memcpy(E+1,tmp+2,1);}
		else{memcpy(tmp,Buffer+14,4);
		if(tmp[0]!=0){memcpy(E+1,tmp,1);}
		else{memcpy(E+1,&N,1);}}
		//---- E[3]
		memcpy(tmp,Buffer+14,4);
		if(tmp[2]!=0){memcpy(E+3,tmp+2,1);}
		else{memcpy(tmp,Buffer+19,4);
		if(tmp[0]!=0){memcpy(E+3,tmp,1);}
		else{memcpy(E+3,&N,1);}}
		//---- F[0]
		memcpy(tmp,Buffer+15,4);
		if(tmp[1]!=0){memcpy(F,tmp+1,1);}
		else{memcpy(F,&N,1);}
		//---- F[2]
		memcpy(tmp,Buffer+15,4);
		if(tmp[3]!=0){memcpy(F+2,tmp+3,1);}
		else{memcpy(tmp,Buffer+21,4);
		if(tmp[0]!=0){memcpy(F+2,tmp,1);}
		else{memcpy(F+2,&N,1);}}
		//---- F[3]
		memcpy(tmp,Buffer+21,4);
		if(tmp[1]!=0){memcpy(F+3,tmp+1,1);}
		else{memcpy(F,&N,1);}
		//---- G[2]
		memcpy(tmp,Buffer+21,4);
		if(tmp[1]!=0){memcpy(G+2,tmp+1,1);}
		else{memcpy(tmp,Buffer+22,4);
		if(tmp[0]!=0){memcpy(G+2,tmp,1);}
		else{memcpy(G+2,&N,1);}}
		//---- G[3]
		memcpy(tmp,Buffer+22,4);
		if(tmp[1]!=0){memcpy(G+3,tmp+1,1);}
		else{memcpy(tmp,Buffer+23,4);
		if(tmp[0]!=0){memcpy(G+3,tmp,1);}
		else{memcpy(G+3,&N,1);}}
		//---- H[1]
		memcpy(tmp,Buffer+14,4);
		if(tmp[2]!=0){memcpy(H+1,tmp+2,1);}
		else{memcpy(tmp,Buffer+19,4);
		if(tmp[0]!=0){memcpy(H+1,tmp,1);}
		else{memcpy(H+1,&N,1);}}
		//---- H[2]
		memcpy(tmp,Buffer+22,4);
		if(tmp[1]!=0){memcpy(H+2,tmp+1,1);}
		else{memcpy(tmp,Buffer+23,4);
		if(tmp[0]!=0){memcpy(H+2,tmp,1);}
		else{memcpy(H+2,&N,1);}}
		//---- H[3]
		memcpy(tmp,Buffer+19,4);
		if(tmp[2]!=0){memcpy(H+3,tmp+2,1);}
		else{memcpy(tmp,Buffer+23,4);
		if(tmp[1]!=0){memcpy(H+3,tmp+1,1);}
		else{memcpy(H+3,&N,1);}}
	////////////////////////////////////////
	//    !  
	////////////////////////////////////////
		int *Rez = new int[9]; //     ;)
		int *TEMP;
		int r = 0;
	//      ...
		//Default
		for(int i=0;i<9;i++)
			Rez[i]=N;
		//Center
		TEMP = tOpt.FindZap(CTile(Buffer+12)); // ,   
		r = TEMP[0];
		if(r>0)
		{
			int tt = tOpt.GetRandomZap(TEMP);
			memcpy(tmp,Buffer+12,4);
			tt += 16384 * tOpt.Rnd(4,GR*tt+tOpt.Rnd(GR,tt));
			Rez[4] = tt;
		}
		GR = (int)tOpt.Rnd(GR,GR+tOpt.Rnd(GR,7623)*(GR+tOpt.Rnd(324,GR)));
		///////////////////////////////////////
		//A
		TEMP = tOpt.FindZap(A); // ,   
		r = TEMP[0];
		if(r>0)
		{
			int tt = tOpt.GetRandomZap(TEMP);
			memcpy(tmp,A,4);
			if(!(CTile(TEMP)==CTile(N,N,N,N)))
			tt += 16384 * tOpt.GetRotNumber(tOpt.GetZapEx(tt),tmp);
			else
			tt += 16384 * tOpt.Rnd(4,GR*tt+tOpt.Rnd(GR,tt));
			Rez[0] = tt;
		}
		delete [] TEMP;
		GR = (int)tOpt.Rnd(GR,GR+tOpt.Rnd(GR,7623)*(GR+tOpt.Rnd(324,GR)));
		//B
		TEMP = tOpt.FindZap(CTile(B)); // ,   
		r = TEMP[0];
		if(r>0)
		{
			int tt = tOpt.GetRandomZap(TEMP);
			memcpy(tmp,B,4);
			if(!(CTile(TEMP)==CTile(N,N,N,N)))
			tt += 16384 * tOpt.GetRotNumber(tOpt.GetZapEx(tt),tmp);
			else
			tt += 16384 * tOpt.Rnd(4,GR*tt+tOpt.Rnd(GR,tt));
			Rez[1] = tt;
		}
		delete [] TEMP;
		GR = (int)tOpt.Rnd(GR,GR+tOpt.Rnd(GR,7623)*(GR+tOpt.Rnd(324,GR)));
		//C
		TEMP = tOpt.FindZap(CTile(C)); // ,   
		r = TEMP[0];
		if(r>0)
		{
			int tt = tOpt.GetRandomZap(TEMP);
			memcpy(tmp,C,4);
			if(!(CTile(TEMP)==CTile(N,N,N,N)))
			tt += 16384 * tOpt.GetRotNumber(tOpt.GetZapEx(tt),tmp);
			else
			tt += 16384 * tOpt.Rnd(4,GR*tt+tOpt.Rnd(GR,tt));
			Rez[2] = tt;
		}
		delete [] TEMP;
		GR = (int)tOpt.Rnd(GR,GR+tOpt.Rnd(GR,7623)*(GR+tOpt.Rnd(324,GR)));
		//D
		TEMP = tOpt.FindZap(CTile(D)); // ,   
		r = TEMP[0];
		if(r>0)
		{
			int tt = tOpt.GetRandomZap(TEMP);
			memcpy(tmp,D,4);
			if(!(CTile(TEMP)==CTile(N,N,N,N)))
			tt += 16384 * tOpt.GetRotNumber(tOpt.GetZapEx(tt),tmp);
			else
			tt += 16384 * tOpt.Rnd(4,GR*tt+tOpt.Rnd(GR,tt));
			Rez[3] = tt;
		}
		delete [] TEMP;
		GR = (int)tOpt.Rnd(GR,GR+tOpt.Rnd(GR,7623)*(GR+tOpt.Rnd(324,GR)));
		//E
		TEMP = tOpt.FindZap(CTile(E)); // ,   
		r = TEMP[0];
		if(r>0)
		{
			int tt = tOpt.GetRandomZap(TEMP);
			memcpy(tmp,E,4);
			if(!(CTile(TEMP)==CTile(N,N,N,N)))
			tt += 16384 * tOpt.GetRotNumber(tOpt.GetZapEx(tt),tmp);
			else
			tt += 16384 * tOpt.Rnd(4,GR*tt+tOpt.Rnd(GR,tt));
			Rez[5] = tt;
		}
		delete [] TEMP;
		GR = (int)tOpt.Rnd(GR,GR+tOpt.Rnd(GR,7623)*(GR+tOpt.Rnd(324,GR)));
		//F
		TEMP = tOpt.FindZap(CTile(F)); // ,   
		r = TEMP[0];
		if(r>0)
		{
			int tt = tOpt.GetRandomZap(TEMP);
			memcpy(tmp,F,4);
			if(!(CTile(TEMP)==CTile(N,N,N,N)))
			tt += 16384 * tOpt.GetRotNumber(tOpt.GetZapEx(tt),tmp);
			else
			tt += 16384 * tOpt.Rnd(4,GR*tt+tOpt.Rnd(GR,tt));
			Rez[6] = tt;
		}
		delete [] TEMP;
		GR = (int)tOpt.Rnd(GR,GR+tOpt.Rnd(GR,7623)*(GR+tOpt.Rnd(324,GR)));
		//G
		TEMP = tOpt.FindZap(CTile(G)); // ,   
		r = TEMP[0];
		if(r>0)
		{
			int tt = tOpt.GetRandomZap(TEMP);
			memcpy(tmp,G,4);
			if(!(CTile(TEMP)==CTile(N,N,N,N)))
			tt += 16384 * tOpt.GetRotNumber(tOpt.GetZapEx(tt),tmp);
			else
			tt += 16384 * tOpt.Rnd(4,GR*tt+tOpt.Rnd(GR,tt));
			Rez[7] = tt;
		}
		delete [] TEMP;
		GR = (int)tOpt.Rnd(GR,GR+tOpt.Rnd(GR,7623)*(GR+tOpt.Rnd(324,GR)));
		//H
		TEMP = tOpt.FindZap(CTile(H)); // ,   
		r = TEMP[0];
		if(r>0)
		{
			int tt = tOpt.GetRandomZap(TEMP);
			memcpy(tmp,H,4);
			if(!(CTile(TEMP)==CTile(N,N,N,N)))
			tt += 16384 * tOpt.GetRotNumber(tOpt.GetZapEx(tt),tmp);
			else
			tt += 16384 * tOpt.Rnd(4,GR*tt+tOpt.Rnd(GR,tt));
			Rez[8] = tt;
		}

	/////////////////////////////////////
	//      Apply producion to map!
	/////////////////////////////////////
		for(int Y=0;Y<3;Y++)
			for(int X=0;X<3;X++)
			{
				//bool mz=(x+X>=2)&&(y+2>=Y); //More Zero
				//bool ld=(x-2+i<MLX)&&(y+2-k<MLY);//Less dimensions
				bool mz = (x+X-1>=0)&&(y+1-Y>=0);
				bool ld = (x+X-1<MLX)&&(y+1-Y<MLY);
				if(mz&&ld)
				{
					map->setTitle(x+X-1,y+1-Y,Rez[Y*3+X]);
				}
			}


	//    ...
		map->refresh();
		delete [] Buffer;
		delete [] tmp;
		delete [] TEMP;
		delete [] A;
		delete [] B;
		delete [] C;
		delete [] D;
		delete [] E;
		delete [] F;
		delete [] G;
		delete [] H;
		delete [] Rez;
	}
	else
	{
// 2:         
		byte *tmp = new byte[4];
		memcpy(tmp+0,&N,1);
		memcpy(tmp+1,&N,1);
		memcpy(tmp+2,&N,1);
		memcpy(tmp+3,&N,1);
		int TIL = tOpt.GetRandomZap(tOpt.FindZap(CTile(tmp)));
		delete [] tmp;

        map->setTitle(x,y, TIL);		
	}
}

void CTex::OnLbnSelchangeMatList()
{
  UpdateData(FROM);
  byte N = MList.GetCaretIndex();
  CurrentMaterial = tOpt.GetCode(N);
}

void CTex::OnBnClickedExtended()
{
  MList.SelectString(0,"");
}

void CTex::RandomizeRect(unsigned int x1, unsigned int y1, unsigned int x2, unsigned int y2)
{
	int X1, X2, Y1, Y2;
	X1 = (x1<x2)?x1:x2;
	X2 = (x1>x2)?x1:x2;
	Y1 = (y1<y2)?y1:y2;
	Y2 = (y1>y2)?y1:y2;

	int MLX = (map->getMapXDimension()-1)/2;
	int MLY = (map->getMapXDimension()-1)/2;

	X1 = (X1<MLX)?X1:MLX;
	X2 = (X2<MLX)?X2:MLX;
	Y1 = (Y1<MLY)?Y1:MLY;
	Y2 = (Y2<MLY)?Y2:MLY;

	X1 = (X1>=0)?X1:0;
	X2 = (X2>=0)?X2:0;
	Y1 = (Y1>=0)?Y1:0;
	Y2 = (Y2>=0)?Y2:0;

	//Inited
	for(int x=X1;x<X2;x++)
	{
		for(int y=Y1;y<Y2;y++)
		{
		//Random replace
			//Load title
			int N = map->getTitle(x,y,false);
			byte RN = 0;//tOpt.GetRotNumber(N);//RotNumb
			//RN=(RN<3)?0:RN-1;
			int N2 = map->getTitle(x,y,true);
			byte *t = tOpt.GetZapEx(N2);
			//byte a,b,c,d;
			//memcpy(&a,t+0,1);
			//memcpy(&b,t+1,1);
			//memcpy(&c,t+2,1);
			//memcpy(&d,t+3,1);
			int *B = tOpt.FindZap(CTile(t)/*CTile(a,b,c,d)*/);
			int k = tOpt.GetRandomZap(B);
			delete [] B;
			if(k>=0)
			{
				for(k;k>=16384;k-=16384);
				byte *r = tOpt.GetZapEx(N);
				delete [] t;
				t = tOpt.GetZapEx(k);
			  int J = tOpt.GetRotNumber(t,r)+RN;
			    delete [] r;
			  for(J;J>=4;J-=4);
			  map->setTitle(x,y, k+J*16384);
			}
		//Random rotate - commented,        
			//CTile aX = CTile(t);
			//if(aX.IsSolidTile())//  ,   
			//{
			//	int i = tOpt.Rnd(4,(unsigned int)time(NULL));
			//	for(int j=0;j<=i;j++)
			//		map->rotateTitle(x,y);
			//	map->setTitle(x,y,9);//**  
			//}
			delete [] t;
		}
	}
}
void CTex::RandomRotRect(unsigned int x1, unsigned int y1, unsigned int x2, unsigned int y2)
{
	int X1, X2, Y1, Y2;
	X1 = (x1<x2)?x1:x2;
	X2 = (x1>x2)?x1:x2;
	Y1 = (y1<y2)?y1:y2;
	Y2 = (y1>y2)?y1:y2;

	int MLX = (map->getMapXDimension()-1)/2;
	int MLY = (map->getMapXDimension()-1)/2;

	X1 = (X1<MLX)?X1:MLX;
	X2 = (X2<MLX)?X2:MLX;
	Y1 = (Y1<MLY)?Y1:MLY;
	Y2 = (Y2<MLY)?Y2:MLY;

	X1 = (X1>=0)?X1:0;
	X2 = (X2>=0)?X2:0;
	Y1 = (Y1>=0)?Y1:0;
	Y2 = (Y2>=0)?Y2:0;

	for(int x=X1;x<X2;x++)
	{
		for(int y=Y1;y<Y2;y++)
		{
		//Random rotate
			int i = map->getTitle(x,y,true);
			bool b=i<64;//Optional!!!
		
			CTile aX = tOpt.GetZap(i);

			if(aX.IsSolidTile() && b)//  ,   
			{
				int i = tOpt.Rnd(4,(unsigned int)time(NULL));
				for(int j=0;j<=i;j++)
					map->rotateTitle(x,y);
				//map->setTitle(x,y,9);//**  
			}
		}
	}
}

void CTex::RefreshInfo(int x,int y)
{
	int i=map->getTitle(x,y,false);
	int j=tOpt.GetRotNumber(i);
	CString t = "";
	i-=j*16384;
	CTile a = tOpt.GetZap(i);
	for(int Z=0;Z<j;Z++)a.Rotate();

	t.Format(" %d",i);
	SetDlgItemText(IDC_TILE_NUM,t);
	t.Format(": %d",j);
	SetDlgItemText(IDC_TILE_ROTATED,t);
	t.Format(": %d ; %d",x,y);
	SetDlgItemText(IDC_TILE_COORDS,t);
	t.Format("%s | %s\r\n%s | %s",tOpt.GetCaption(a.A-1),tOpt.GetCaption(a.B-1),tOpt.GetCaption(a.C-1),tOpt.GetCaption(a.D-1));
	SetDlgItemText(IDC_TILE_MATS,t);
}
void CTex::OnBnClickedRndMap()
{
	RandomizeRect(0,0,map->getMapXDimension(),map->getMapYDimension());
	map->refresh();
}

void CTex::OnTimer(UINT nIDEvent)
{
	if(nIDEvent==0)
	{
		GR+=rand();
		if(GR>100000000)
			GR=0;
		srand(GR);
		SetTimer(0,10,NULL);
	}
	CPlugin::OnTimer(nIDEvent);
}

void CTex::OnStnClickedSingleTitle()
{
	// TODO: Add your control notification handler code here
}
